
This is a patch file against 0.2.9.

Change to directory gnupg-0.2.9 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.2.10.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.2.10 now.



Prereq: 0.2.9

diff -urN gnupg-0.2.9/VERSION gnupg-0.2.10/VERSION
--- gnupg-0.2.9/VERSION	Thu Feb 26 15:34:27 1998
+++ gnupg-0.2.10/VERSION	Fri Feb 27 18:20:56 1998
@@ -1 +1 @@
-0.2.9
+0.2.10

diff -urN gnupg-0.2.9/ChangeLog gnupg-0.2.10/ChangeLog
--- gnupg-0.2.9/ChangeLog	Thu Feb 26 17:10:51 1998
+++ gnupg-0.2.10/ChangeLog	Fri Feb 27 13:14:41 1998
@@ -1,3 +1,7 @@
+Fri Feb 27 13:14:17 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* configure.in (--disable-m-guard): New.
+
 Thu Feb 26 17:09:27 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* configure.in, acinclude.m4, intl/, po/: New macros taken
diff -urN gnupg-0.2.9/INSTALL gnupg-0.2.10/INSTALL
--- gnupg-0.2.9/INSTALL	Thu Feb 26 13:39:14 1998
+++ gnupg-0.2.10/INSTALL	Fri Feb 27 13:18:13 1998
@@ -4,10 +4,10 @@
 Configure options for GNUPG
 ===========================
 
---with-zlib	    Forces usage of the local zlib sources. Default is
-		    to use the (sahred) library of the system.
+--with-included-zlib Forces usage of the local zlib sources. Default is
+		     to use the (shared) library of the system.
 
---disable-nls	    Disable NLS support
+--disable-nls	    Disable NLS support (See ABOUT-NLS)
 
 --enable-m-debug    Compile with the integrated malloc debugging stuff.
 		    This makes the program slower but is checks every
@@ -18,13 +18,18 @@
 		    option "--debug 128" displays a memory statistic after
 		    the program run.
 
+--disable-m-guard   Disable the integrated malloc checking code. As a
+		    side-effect, this removes all debugging code and uses
+		    the -O2 flag for all C files.
+
+
 Problems
 ========
 
 If you have compile problems, use the configure options "--with-zlib" and
-"--disable-nls".
+"--disable-nls" (See ABOUT-NLS).
 
-I cant check alls assembles files; so if you have problems assembling them
+I cant check all assembler files; so if you have problems assembling them
 (or the program crashes), simply delete the files in the mpi/<cpu> directory.
 The configure scripts may consider several subdirectories to get all
 available assembler files; be sure to delete the correct ones. The
diff -urN gnupg-0.2.9/NEWS gnupg-0.2.10/NEWS
--- gnupg-0.2.9/NEWS	Thu Feb 26 17:08:43 1998
+++ gnupg-0.2.10/NEWS	Fri Feb 27 18:20:48 1998
@@ -1,3 +1,25 @@
+Noteworthy changes in version 0.2.10
+------------------------------------
+
+    * Code for the alpha is much faster (about 20 times); the data
+      was misaligned and the kernel traps this, so nearly all time
+      was used by system to trap the misalignments and to write
+      syslog messages. Shame on me and thanks to Ralph for
+      pointing me at this while drinking some beer yesterday.
+
+    * Changed some configure options and add an option
+      --disable-m-guard to remove the memory checking code
+      and to compile everthing with optimization on.
+
+    * New environment variable GNUPGHOME, which can be used to set
+      another homedir than ~/.gnupg.  Changed default homedir for
+      Windoze version to c:/gnupg.
+
+    * Fixed detached signatures; detached PGP signatures caused a SEGV.
+
+    * The Windoze version works (as usual w/o a strong RNG).
+
+
 Noteworthy changes in version 0.2.9
 -----------------------------------
 
diff -urN gnupg-0.2.9/acconfig.h gnupg-0.2.10/acconfig.h
--- gnupg-0.2.9/acconfig.h	Mon Feb 23 13:24:20 1998
+++ gnupg-0.2.10/acconfig.h	Fri Feb 27 10:41:40 1998
@@ -28,6 +28,7 @@
 @TOP@
 
 #undef M_DEBUG
+#undef M_GUARD
 #undef VERSION
 #undef PACKAGE
 #undef G10_LOCALEDIR
diff -urN gnupg-0.2.9/acinclude.m4 gnupg-0.2.10/acinclude.m4
--- gnupg-0.2.9/acinclude.m4	Thu Feb 26 16:37:01 1998
+++ gnupg-0.2.10/acinclude.m4	Fri Feb 27 13:14:10 1998
@@ -22,7 +22,7 @@
     ], wk_cv_typedef_$1=yes, wk_cv_typedef_$1=no )])
     AC_MSG_RESULT($wk_cv_typedef_$1)
     if test "$wk_cv_typedef_$1" = yes; then
-	AC_DEFINE($2)
+        AC_DEFINE($2)
     fi
   ])
 
@@ -37,11 +37,11 @@
 dnl
 define(WK_LINK_FILES,
   [ if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$1"
-	wk_link_files_dst="$2"
+        wk_link_files_src="$1"
+        wk_link_files_dst="$2"
     else
-	wk_link_files_src="$wk_link_files_src $1"
-	wk_link_files_dst="$wk_link_files_dst $2"
+        wk_link_files_src="$wk_link_files_src $1"
+        wk_link_files_dst="$wk_link_files_dst $2"
     fi
   ])
 define(WK_DO_LINK_FILES,
@@ -54,38 +54,38 @@
 dnl
 define(WK_CHECK_ENDIAN,
   [ if test "$cross_compiling" = yes; then
-	AC_MSG_WARN(cross compiling; assuming little endianess)
+        AC_MSG_WARN(cross compiling; assuming little endianess)
     fi
     AC_MSG_CHECKING(endianess)
     AC_CACHE_VAL(wk_cv_c_endian,
       [ wk_cv_c_endian=unknown
-	# See if sys/param.h defines the BYTE_ORDER macro.
-	AC_TRY_COMPILE([#include <sys/types.h>
-	#include <sys/param.h>], [
-	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
-	 bogus endian macros
-	#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
-	AC_TRY_COMPILE([#include <sys/types.h>
-	#include <sys/param.h>], [
-	#if BYTE_ORDER != BIG_ENDIAN
-	 not big endian
-	#endif], wk_cv_c_endian=big, wk_cv_c_endian=little)])
-	if test "$wk_cv_c_endian" = unknown; then
-	    AC_TRY_RUN([main () {
-	      /* Are we little or big endian?  From Harbison&Steele.  */
-	      union
-	      {
-		long l;
-		char c[sizeof (long)];
-	      } u;
-	      u.l = 1;
-	      exit (u.c[sizeof (long) - 1] == 1);
-	      }],
-	      wk_cv_c_endian=little,
-	      wk_cv_c_endian=big,
-	      wk_cv_c_endian=little
-	    )
-	fi
+        # See if sys/param.h defines the BYTE_ORDER macro.
+        AC_TRY_COMPILE([#include <sys/types.h>
+        #include <sys/param.h>], [
+        #if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+         bogus endian macros
+        #endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
+        AC_TRY_COMPILE([#include <sys/types.h>
+        #include <sys/param.h>], [
+        #if BYTE_ORDER != BIG_ENDIAN
+         not big endian
+        #endif], wk_cv_c_endian=big, wk_cv_c_endian=little)])
+        if test "$wk_cv_c_endian" = unknown; then
+            AC_TRY_RUN([main () {
+              /* Are we little or big endian?  From Harbison&Steele.  */
+              union
+              {
+                long l;
+                char c[sizeof (long)];
+              } u;
+              u.l = 1;
+              exit (u.c[sizeof (long) - 1] == 1);
+              }],
+              wk_cv_c_endian=little,
+              wk_cv_c_endian=big,
+              wk_cv_c_endian=little
+            )
+        fi
       ])
     AC_MSG_RESULT([$wk_cv_c_endian])
     if test "$wk_cv_c_endian" = little; then
@@ -102,12 +102,12 @@
     wk_hostcheck="$target"
     AC_CACHE_VAL(wk_cv_hostcheck, [ wk_cv_hostcheck="$wk_hostcheck" ])
     if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
-	AC_MSG_RESULT(changed)
-	AC_MSG_WARN(config.cache exists!)
-	AC_MSG_ERROR(you must do 'make distclean' first to compile for
-		 different target or different parameters.)
+        AC_MSG_RESULT(changed)
+        AC_MSG_WARN(config.cache exists!)
+        AC_MSG_ERROR(you must do 'make distclean' first to compile for
+                 different target or different parameters.)
     else
-	AC_MSG_RESULT(ok)
+        AC_MSG_RESULT(ok)
     fi
   ])
 
@@ -142,8 +142,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if [$3]; then
-	ac_cv_path_$1="$ac_dir/$ac_word"
-	break
+        ac_cv_path_$1="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -206,7 +206,7 @@
   [AC_MSG_CHECKING([whether NLS is requested])
     dnl Default is enabled NLS
     AC_ARG_ENABLE(nls,
-      [  --disable-nls		 do not use Native Language Support],
+      [  --disable-nls           do not use Native Language Support],
       USE_NLS=$enableval, USE_NLS=yes)
     AC_MSG_RESULT($USE_NLS)
     AC_SUBST(USE_NLS)
@@ -218,129 +218,129 @@
       AC_DEFINE(ENABLE_NLS)
       AC_MSG_CHECKING([whether included gettext is requested])
       AC_ARG_WITH(included-gettext,
-	[  --with-included-gettext use the GNU gettext library included here],
-	nls_cv_force_use_gnu_gettext=$withval,
-	nls_cv_force_use_gnu_gettext=no)
+        [  --with-included-gettext use the GNU gettext library included here],
+        nls_cv_force_use_gnu_gettext=$withval,
+        nls_cv_force_use_gnu_gettext=no)
       AC_MSG_RESULT($nls_cv_force_use_gnu_gettext)
 
       nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
       if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
-	dnl User does not insist on using GNU NLS library.  Figure out what
-	dnl to use.  If gettext or catgets are available (in this order) we
-	dnl use this.  Else we have to fall back to GNU NLS library.
-	dnl catgets is only used if permitted by option --with-catgets.
-	nls_cv_header_intl=
-	nls_cv_header_libgt=
-	CATOBJEXT=NONE
-
-	AC_CHECK_HEADER(libintl.h,
-	  [AC_CACHE_CHECK([for gettext in libc], gt_cv_func_gettext_libc,
-	    [AC_TRY_LINK([#include <libintl.h>], [return (int) gettext ("")],
-	       gt_cv_func_gettext_libc=yes, gt_cv_func_gettext_libc=no)])
-
-	   if test "$gt_cv_func_gettext_libc" != "yes"; then
-	     AC_CHECK_LIB(intl, bindtextdomain,
-	       [AC_CACHE_CHECK([for gettext in libintl],
-		 gt_cv_func_gettext_libintl,
-		 [AC_TRY_LINK([], [return (int) gettext ("")],
-		 gt_cv_func_gettext_libintl=yes,
-		 gt_cv_func_gettext_libintl=no)])])
-	   fi
-
-	   if test "$gt_cv_func_gettext_libc" = "yes" \
-	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
-	      AC_DEFINE(HAVE_GETTEXT)
-	      AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
-		[test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)dnl
-	      if test "$MSGFMT" != "no"; then
-		AC_CHECK_FUNCS(dcgettext)
-		AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
-		AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-		  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-		AC_TRY_LINK(, [extern int _nl_msg_cat_cntr;
-			       return _nl_msg_cat_cntr],
-		  [CATOBJEXT=.gmo
-		   DATADIRNAME=share],
-		  [CATOBJEXT=.mo
-		   DATADIRNAME=lib])
-		INSTOBJEXT=.mo
-	      fi
-	    fi
-	])
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  AC_MSG_CHECKING([whether catgets can be used])
-	  AC_ARG_WITH(catgets,
-	    [  --with-catgets	       use catgets functions if available],
-	    nls_cv_use_catgets=$withval, nls_cv_use_catgets=no)
-	  AC_MSG_RESULT($nls_cv_use_catgets)
-
-	  if test "$nls_cv_use_catgets" = "yes"; then
-	    dnl No gettext in C library.  Try catgets next.
-	    AC_CHECK_LIB(i, main)
-	    AC_CHECK_FUNC(catgets,
-	      [AC_DEFINE(HAVE_CATGETS)
-	       INTLOBJS="\$(CATOBJS)"
-	       AC_PATH_PROG(GENCAT, gencat, no)dnl
-	       if test "$GENCAT" != "no"; then
-		 AC_PATH_PROG(GMSGFMT, gmsgfmt, no)
-		 if test "$GMSGFMT" = "no"; then
-		   AM_PATH_PROG_WITH_TEST(GMSGFMT, msgfmt,
-		    [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)
-		 fi
-		 AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-		   [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-		 USE_INCLUDED_LIBINTL=yes
-		 CATOBJEXT=.cat
-		 INSTOBJEXT=.cat
-		 DATADIRNAME=lib
-		 INTLDEPS='$(top_builddir)/intl/libintl.a'
-		 INTLLIBS=$INTLDEPS
-		 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-		 nls_cv_header_intl=intl/libintl.h
-		 nls_cv_header_libgt=intl/libgettext.h
-	       fi])
-	  fi
-	fi
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  dnl Neither gettext nor catgets in included in the C library.
-	  dnl Fall back on GNU gettext library.
-	  nls_cv_use_gnu_gettext=yes
-	fi
+        dnl User does not insist on using GNU NLS library.  Figure out what
+        dnl to use.  If gettext or catgets are available (in this order) we
+        dnl use this.  Else we have to fall back to GNU NLS library.
+        dnl catgets is only used if permitted by option --with-catgets.
+        nls_cv_header_intl=
+        nls_cv_header_libgt=
+        CATOBJEXT=NONE
+
+        AC_CHECK_HEADER(libintl.h,
+          [AC_CACHE_CHECK([for gettext in libc], gt_cv_func_gettext_libc,
+            [AC_TRY_LINK([#include <libintl.h>], [return (int) gettext ("")],
+               gt_cv_func_gettext_libc=yes, gt_cv_func_gettext_libc=no)])
+
+           if test "$gt_cv_func_gettext_libc" != "yes"; then
+             AC_CHECK_LIB(intl, bindtextdomain,
+               [AC_CACHE_CHECK([for gettext in libintl],
+                 gt_cv_func_gettext_libintl,
+                 [AC_TRY_LINK([], [return (int) gettext ("")],
+                 gt_cv_func_gettext_libintl=yes,
+                 gt_cv_func_gettext_libintl=no)])])
+           fi
+
+           if test "$gt_cv_func_gettext_libc" = "yes" \
+              || test "$gt_cv_func_gettext_libintl" = "yes"; then
+              AC_DEFINE(HAVE_GETTEXT)
+              AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
+                [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)dnl
+              if test "$MSGFMT" != "no"; then
+                AC_CHECK_FUNCS(dcgettext)
+                AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+                AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+                  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+                AC_TRY_LINK(, [extern int _nl_msg_cat_cntr;
+                               return _nl_msg_cat_cntr],
+                  [CATOBJEXT=.gmo
+                   DATADIRNAME=share],
+                  [CATOBJEXT=.mo
+                   DATADIRNAME=lib])
+                INSTOBJEXT=.mo
+              fi
+            fi
+        ])
+
+        if test "$CATOBJEXT" = "NONE"; then
+          AC_MSG_CHECKING([whether catgets can be used])
+          AC_ARG_WITH(catgets,
+            [  --with-catgets          use catgets functions if available],
+            nls_cv_use_catgets=$withval, nls_cv_use_catgets=no)
+          AC_MSG_RESULT($nls_cv_use_catgets)
+
+          if test "$nls_cv_use_catgets" = "yes"; then
+            dnl No gettext in C library.  Try catgets next.
+            AC_CHECK_LIB(i, main)
+            AC_CHECK_FUNC(catgets,
+              [AC_DEFINE(HAVE_CATGETS)
+               INTLOBJS="\$(CATOBJS)"
+               AC_PATH_PROG(GENCAT, gencat, no)dnl
+               if test "$GENCAT" != "no"; then
+                 AC_PATH_PROG(GMSGFMT, gmsgfmt, no)
+                 if test "$GMSGFMT" = "no"; then
+                   AM_PATH_PROG_WITH_TEST(GMSGFMT, msgfmt,
+                    [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)
+                 fi
+                 AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+                   [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+                 USE_INCLUDED_LIBINTL=yes
+                 CATOBJEXT=.cat
+                 INSTOBJEXT=.cat
+                 DATADIRNAME=lib
+                 INTLDEPS='$(top_builddir)/intl/libintl.a'
+                 INTLLIBS=$INTLDEPS
+                 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+                 nls_cv_header_intl=intl/libintl.h
+                 nls_cv_header_libgt=intl/libgettext.h
+               fi])
+          fi
+        fi
+
+        if test "$CATOBJEXT" = "NONE"; then
+          dnl Neither gettext nor catgets in included in the C library.
+          dnl Fall back on GNU gettext library.
+          nls_cv_use_gnu_gettext=yes
+        fi
       fi
 
       if test "$nls_cv_use_gnu_gettext" = "yes"; then
-	dnl Mark actions used to generate GNU NLS library.
-	INTLOBJS="\$(GETTOBJS)"
-	AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
-	  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], msgfmt)
-	AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
-	AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-	  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-	AC_SUBST(MSGFMT)
-	USE_INCLUDED_LIBINTL=yes
-	CATOBJEXT=.gmo
-	INSTOBJEXT=.mo
-	DATADIRNAME=share
-	INTLDEPS='$(top_builddir)/intl/libintl.a'
-	INTLLIBS=$INTLDEPS
-	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-	nls_cv_header_intl=intl/libintl.h
-	nls_cv_header_libgt=intl/libgettext.h
+        dnl Mark actions used to generate GNU NLS library.
+        INTLOBJS="\$(GETTOBJS)"
+        AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
+          [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], msgfmt)
+        AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+        AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+          [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+        AC_SUBST(MSGFMT)
+        USE_INCLUDED_LIBINTL=yes
+        CATOBJEXT=.gmo
+        INSTOBJEXT=.mo
+        DATADIRNAME=share
+        INTLDEPS='$(top_builddir)/intl/libintl.a'
+        INTLLIBS=$INTLDEPS
+        LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+        nls_cv_header_intl=intl/libintl.h
+        nls_cv_header_libgt=intl/libgettext.h
       fi
 
       dnl Test whether we really found GNU xgettext.
       if test "$XGETTEXT" != ":"; then
-	dnl If it is no GNU xgettext we define it as : so that the
-	dnl Makefiles still can work.
-	if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
-	  : ;
-	else
-	  AC_MSG_RESULT(
-	    [found xgettext programs is not GNU xgettext; ignore it])
-	  XGETTEXT=":"
-	fi
+        dnl If it is no GNU xgettext we define it as : so that the
+        dnl Makefiles still can work.
+        if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
+          : ;
+        else
+          AC_MSG_RESULT(
+            [found xgettext programs is not GNU xgettext; ignore it])
+          XGETTEXT=":"
+        fi
       fi
 
       # We need to process the po/ directory.
@@ -415,9 +415,9 @@
        AC_MSG_CHECKING(for catalogs to be installed)
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
-	 case "$ALL_LINGUAS" in
-	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
-	 esac
+         case "$ALL_LINGUAS" in
+          *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+         esac
        done
        LINGUAS=$NEW_LINGUAS
        AC_MSG_RESULT($LINGUAS)
@@ -442,7 +442,7 @@
 
    dnl Determine which catalog format we have (if any is needed)
    dnl For now we know about two different formats:
-   dnl	 Linux libc-5 and the normal X/Open format
+   dnl   Linux libc-5 and the normal X/Open format
    test -d intl || mkdir intl
    if test "$CATOBJEXT" = ".cat"; then
      AC_CHECK_HEADER(linux/version.h, msgformat=linux, msgformat=xopen)
@@ -456,7 +456,7 @@
      $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
 
    dnl In the intl/Makefile.in we have a special dependency which makes
-   dnl only sense for gettext.	We comment this out for non-gettext
+   dnl only sense for gettext.  We comment this out for non-gettext
    dnl packages.
    if test "$PACKAGE" = "gettext"; then
      GT_NO="#NO#"
@@ -498,7 +498,7 @@
    fi
    rm -f po/POTFILES
    sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
-	< $srcdir/po/POTFILES.in > po/POTFILES
+        < $srcdir/po/POTFILES.in > po/POTFILES
   ])
 
 
diff -urN gnupg-0.2.9/aclocal.m4 gnupg-0.2.10/aclocal.m4
--- gnupg-0.2.9/aclocal.m4	Thu Feb 26 16:40:36 1998
+++ gnupg-0.2.10/aclocal.m4	Fri Feb 27 15:27:09 1998
@@ -34,7 +34,7 @@
     ], wk_cv_typedef_$1=yes, wk_cv_typedef_$1=no )])
     AC_MSG_RESULT($wk_cv_typedef_$1)
     if test "$wk_cv_typedef_$1" = yes; then
-	AC_DEFINE($2)
+        AC_DEFINE($2)
     fi
   ])
 
@@ -49,11 +49,11 @@
 dnl
 define(WK_LINK_FILES,
   [ if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$1"
-	wk_link_files_dst="$2"
+        wk_link_files_src="$1"
+        wk_link_files_dst="$2"
     else
-	wk_link_files_src="$wk_link_files_src $1"
-	wk_link_files_dst="$wk_link_files_dst $2"
+        wk_link_files_src="$wk_link_files_src $1"
+        wk_link_files_dst="$wk_link_files_dst $2"
     fi
   ])
 define(WK_DO_LINK_FILES,
@@ -66,38 +66,38 @@
 dnl
 define(WK_CHECK_ENDIAN,
   [ if test "$cross_compiling" = yes; then
-	AC_MSG_WARN(cross compiling; assuming little endianess)
+        AC_MSG_WARN(cross compiling; assuming little endianess)
     fi
     AC_MSG_CHECKING(endianess)
     AC_CACHE_VAL(wk_cv_c_endian,
       [ wk_cv_c_endian=unknown
-	# See if sys/param.h defines the BYTE_ORDER macro.
-	AC_TRY_COMPILE([#include <sys/types.h>
-	#include <sys/param.h>], [
-	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
-	 bogus endian macros
-	#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
-	AC_TRY_COMPILE([#include <sys/types.h>
-	#include <sys/param.h>], [
-	#if BYTE_ORDER != BIG_ENDIAN
-	 not big endian
-	#endif], wk_cv_c_endian=big, wk_cv_c_endian=little)])
-	if test "$wk_cv_c_endian" = unknown; then
-	    AC_TRY_RUN([main () {
-	      /* Are we little or big endian?  From Harbison&Steele.  */
-	      union
-	      {
-		long l;
-		char c[sizeof (long)];
-	      } u;
-	      u.l = 1;
-	      exit (u.c[sizeof (long) - 1] == 1);
-	      }],
-	      wk_cv_c_endian=little,
-	      wk_cv_c_endian=big,
-	      wk_cv_c_endian=little
-	    )
-	fi
+        # See if sys/param.h defines the BYTE_ORDER macro.
+        AC_TRY_COMPILE([#include <sys/types.h>
+        #include <sys/param.h>], [
+        #if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+         bogus endian macros
+        #endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
+        AC_TRY_COMPILE([#include <sys/types.h>
+        #include <sys/param.h>], [
+        #if BYTE_ORDER != BIG_ENDIAN
+         not big endian
+        #endif], wk_cv_c_endian=big, wk_cv_c_endian=little)])
+        if test "$wk_cv_c_endian" = unknown; then
+            AC_TRY_RUN([main () {
+              /* Are we little or big endian?  From Harbison&Steele.  */
+              union
+              {
+                long l;
+                char c[sizeof (long)];
+              } u;
+              u.l = 1;
+              exit (u.c[sizeof (long) - 1] == 1);
+              }],
+              wk_cv_c_endian=little,
+              wk_cv_c_endian=big,
+              wk_cv_c_endian=little
+            )
+        fi
       ])
     AC_MSG_RESULT([$wk_cv_c_endian])
     if test "$wk_cv_c_endian" = little; then
@@ -114,12 +114,12 @@
     wk_hostcheck="$target"
     AC_CACHE_VAL(wk_cv_hostcheck, [ wk_cv_hostcheck="$wk_hostcheck" ])
     if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
-	AC_MSG_RESULT(changed)
-	AC_MSG_WARN(config.cache exists!)
-	AC_MSG_ERROR(you must do 'make distclean' first to compile for
-		 different target or different parameters.)
+        AC_MSG_RESULT(changed)
+        AC_MSG_WARN(config.cache exists!)
+        AC_MSG_ERROR(you must do 'make distclean' first to compile for
+                 different target or different parameters.)
     else
-	AC_MSG_RESULT(ok)
+        AC_MSG_RESULT(ok)
     fi
   ])
 
@@ -152,8 +152,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if [$3]; then
-	ac_cv_path_$1="$ac_dir/$ac_word"
-	break
+        ac_cv_path_$1="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -212,7 +212,7 @@
   [AC_MSG_CHECKING([whether NLS is requested])
     dnl Default is enabled NLS
     AC_ARG_ENABLE(nls,
-      [  --disable-nls		 do not use Native Language Support],
+      [  --disable-nls           do not use Native Language Support],
       USE_NLS=$enableval, USE_NLS=yes)
     AC_MSG_RESULT($USE_NLS)
     AC_SUBST(USE_NLS)
@@ -224,129 +224,129 @@
       AC_DEFINE(ENABLE_NLS)
       AC_MSG_CHECKING([whether included gettext is requested])
       AC_ARG_WITH(included-gettext,
-	[  --with-included-gettext use the GNU gettext library included here],
-	nls_cv_force_use_gnu_gettext=$withval,
-	nls_cv_force_use_gnu_gettext=no)
+        [  --with-included-gettext use the GNU gettext library included here],
+        nls_cv_force_use_gnu_gettext=$withval,
+        nls_cv_force_use_gnu_gettext=no)
       AC_MSG_RESULT($nls_cv_force_use_gnu_gettext)
 
       nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
       if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
-	dnl User does not insist on using GNU NLS library.  Figure out what
-	dnl to use.  If gettext or catgets are available (in this order) we
-	dnl use this.  Else we have to fall back to GNU NLS library.
-	dnl catgets is only used if permitted by option --with-catgets.
-	nls_cv_header_intl=
-	nls_cv_header_libgt=
-	CATOBJEXT=NONE
-
-	AC_CHECK_HEADER(libintl.h,
-	  [AC_CACHE_CHECK([for gettext in libc], gt_cv_func_gettext_libc,
-	    [AC_TRY_LINK([#include <libintl.h>], [return (int) gettext ("")],
-	       gt_cv_func_gettext_libc=yes, gt_cv_func_gettext_libc=no)])
-
-	   if test "$gt_cv_func_gettext_libc" != "yes"; then
-	     AC_CHECK_LIB(intl, bindtextdomain,
-	       [AC_CACHE_CHECK([for gettext in libintl],
-		 gt_cv_func_gettext_libintl,
-		 [AC_TRY_LINK([], [return (int) gettext ("")],
-		 gt_cv_func_gettext_libintl=yes,
-		 gt_cv_func_gettext_libintl=no)])])
-	   fi
-
-	   if test "$gt_cv_func_gettext_libc" = "yes" \
-	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
-	      AC_DEFINE(HAVE_GETTEXT)
-	      AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
-		[test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)dnl
-	      if test "$MSGFMT" != "no"; then
-		AC_CHECK_FUNCS(dcgettext)
-		AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
-		AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-		  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-		AC_TRY_LINK(, [extern int _nl_msg_cat_cntr;
-			       return _nl_msg_cat_cntr],
-		  [CATOBJEXT=.gmo
-		   DATADIRNAME=share],
-		  [CATOBJEXT=.mo
-		   DATADIRNAME=lib])
-		INSTOBJEXT=.mo
-	      fi
-	    fi
-	])
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  AC_MSG_CHECKING([whether catgets can be used])
-	  AC_ARG_WITH(catgets,
-	    [  --with-catgets	       use catgets functions if available],
-	    nls_cv_use_catgets=$withval, nls_cv_use_catgets=no)
-	  AC_MSG_RESULT($nls_cv_use_catgets)
-
-	  if test "$nls_cv_use_catgets" = "yes"; then
-	    dnl No gettext in C library.  Try catgets next.
-	    AC_CHECK_LIB(i, main)
-	    AC_CHECK_FUNC(catgets,
-	      [AC_DEFINE(HAVE_CATGETS)
-	       INTLOBJS="\$(CATOBJS)"
-	       AC_PATH_PROG(GENCAT, gencat, no)dnl
-	       if test "$GENCAT" != "no"; then
-		 AC_PATH_PROG(GMSGFMT, gmsgfmt, no)
-		 if test "$GMSGFMT" = "no"; then
-		   AM_PATH_PROG_WITH_TEST(GMSGFMT, msgfmt,
-		    [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)
-		 fi
-		 AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-		   [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-		 USE_INCLUDED_LIBINTL=yes
-		 CATOBJEXT=.cat
-		 INSTOBJEXT=.cat
-		 DATADIRNAME=lib
-		 INTLDEPS='$(top_builddir)/intl/libintl.a'
-		 INTLLIBS=$INTLDEPS
-		 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-		 nls_cv_header_intl=intl/libintl.h
-		 nls_cv_header_libgt=intl/libgettext.h
-	       fi])
-	  fi
-	fi
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  dnl Neither gettext nor catgets in included in the C library.
-	  dnl Fall back on GNU gettext library.
-	  nls_cv_use_gnu_gettext=yes
-	fi
+        dnl User does not insist on using GNU NLS library.  Figure out what
+        dnl to use.  If gettext or catgets are available (in this order) we
+        dnl use this.  Else we have to fall back to GNU NLS library.
+        dnl catgets is only used if permitted by option --with-catgets.
+        nls_cv_header_intl=
+        nls_cv_header_libgt=
+        CATOBJEXT=NONE
+
+        AC_CHECK_HEADER(libintl.h,
+          [AC_CACHE_CHECK([for gettext in libc], gt_cv_func_gettext_libc,
+            [AC_TRY_LINK([#include <libintl.h>], [return (int) gettext ("")],
+               gt_cv_func_gettext_libc=yes, gt_cv_func_gettext_libc=no)])
+
+           if test "$gt_cv_func_gettext_libc" != "yes"; then
+             AC_CHECK_LIB(intl, bindtextdomain,
+               [AC_CACHE_CHECK([for gettext in libintl],
+                 gt_cv_func_gettext_libintl,
+                 [AC_TRY_LINK([], [return (int) gettext ("")],
+                 gt_cv_func_gettext_libintl=yes,
+                 gt_cv_func_gettext_libintl=no)])])
+           fi
+
+           if test "$gt_cv_func_gettext_libc" = "yes" \
+              || test "$gt_cv_func_gettext_libintl" = "yes"; then
+              AC_DEFINE(HAVE_GETTEXT)
+              AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
+                [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)dnl
+              if test "$MSGFMT" != "no"; then
+                AC_CHECK_FUNCS(dcgettext)
+                AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+                AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+                  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+                AC_TRY_LINK(, [extern int _nl_msg_cat_cntr;
+                               return _nl_msg_cat_cntr],
+                  [CATOBJEXT=.gmo
+                   DATADIRNAME=share],
+                  [CATOBJEXT=.mo
+                   DATADIRNAME=lib])
+                INSTOBJEXT=.mo
+              fi
+            fi
+        ])
+
+        if test "$CATOBJEXT" = "NONE"; then
+          AC_MSG_CHECKING([whether catgets can be used])
+          AC_ARG_WITH(catgets,
+            [  --with-catgets          use catgets functions if available],
+            nls_cv_use_catgets=$withval, nls_cv_use_catgets=no)
+          AC_MSG_RESULT($nls_cv_use_catgets)
+
+          if test "$nls_cv_use_catgets" = "yes"; then
+            dnl No gettext in C library.  Try catgets next.
+            AC_CHECK_LIB(i, main)
+            AC_CHECK_FUNC(catgets,
+              [AC_DEFINE(HAVE_CATGETS)
+               INTLOBJS="\$(CATOBJS)"
+               AC_PATH_PROG(GENCAT, gencat, no)dnl
+               if test "$GENCAT" != "no"; then
+                 AC_PATH_PROG(GMSGFMT, gmsgfmt, no)
+                 if test "$GMSGFMT" = "no"; then
+                   AM_PATH_PROG_WITH_TEST(GMSGFMT, msgfmt,
+                    [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], no)
+                 fi
+                 AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+                   [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+                 USE_INCLUDED_LIBINTL=yes
+                 CATOBJEXT=.cat
+                 INSTOBJEXT=.cat
+                 DATADIRNAME=lib
+                 INTLDEPS='$(top_builddir)/intl/libintl.a'
+                 INTLLIBS=$INTLDEPS
+                 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+                 nls_cv_header_intl=intl/libintl.h
+                 nls_cv_header_libgt=intl/libgettext.h
+               fi])
+          fi
+        fi
+
+        if test "$CATOBJEXT" = "NONE"; then
+          dnl Neither gettext nor catgets in included in the C library.
+          dnl Fall back on GNU gettext library.
+          nls_cv_use_gnu_gettext=yes
+        fi
       fi
 
       if test "$nls_cv_use_gnu_gettext" = "yes"; then
-	dnl Mark actions used to generate GNU NLS library.
-	INTLOBJS="\$(GETTOBJS)"
-	AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
-	  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], msgfmt)
-	AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
-	AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
-	  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
-	AC_SUBST(MSGFMT)
-	USE_INCLUDED_LIBINTL=yes
-	CATOBJEXT=.gmo
-	INSTOBJEXT=.mo
-	DATADIRNAME=share
-	INTLDEPS='$(top_builddir)/intl/libintl.a'
-	INTLLIBS=$INTLDEPS
-	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-	nls_cv_header_intl=intl/libintl.h
-	nls_cv_header_libgt=intl/libgettext.h
+        dnl Mark actions used to generate GNU NLS library.
+        INTLOBJS="\$(GETTOBJS)"
+        AM_PATH_PROG_WITH_TEST(MSGFMT, msgfmt,
+          [test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"], msgfmt)
+        AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
+        AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
+          [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+        AC_SUBST(MSGFMT)
+        USE_INCLUDED_LIBINTL=yes
+        CATOBJEXT=.gmo
+        INSTOBJEXT=.mo
+        DATADIRNAME=share
+        INTLDEPS='$(top_builddir)/intl/libintl.a'
+        INTLLIBS=$INTLDEPS
+        LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+        nls_cv_header_intl=intl/libintl.h
+        nls_cv_header_libgt=intl/libgettext.h
       fi
 
       dnl Test whether we really found GNU xgettext.
       if test "$XGETTEXT" != ":"; then
-	dnl If it is no GNU xgettext we define it as : so that the
-	dnl Makefiles still can work.
-	if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
-	  : ;
-	else
-	  AC_MSG_RESULT(
-	    [found xgettext programs is not GNU xgettext; ignore it])
-	  XGETTEXT=":"
-	fi
+        dnl If it is no GNU xgettext we define it as : so that the
+        dnl Makefiles still can work.
+        if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
+          : ;
+        else
+          AC_MSG_RESULT(
+            [found xgettext programs is not GNU xgettext; ignore it])
+          XGETTEXT=":"
+        fi
       fi
 
       # We need to process the po/ directory.
@@ -421,9 +421,9 @@
        AC_MSG_CHECKING(for catalogs to be installed)
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
-	 case "$ALL_LINGUAS" in
-	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
-	 esac
+         case "$ALL_LINGUAS" in
+          *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+         esac
        done
        LINGUAS=$NEW_LINGUAS
        AC_MSG_RESULT($LINGUAS)
@@ -448,7 +448,7 @@
 
    dnl Determine which catalog format we have (if any is needed)
    dnl For now we know about two different formats:
-   dnl	 Linux libc-5 and the normal X/Open format
+   dnl   Linux libc-5 and the normal X/Open format
    test -d intl || mkdir intl
    if test "$CATOBJEXT" = ".cat"; then
      AC_CHECK_HEADER(linux/version.h, msgformat=linux, msgformat=xopen)
@@ -462,7 +462,7 @@
      $srcdir/intl/po2tbl.sed.in > intl/po2tbl.sed
 
    dnl In the intl/Makefile.in we have a special dependency which makes
-   dnl only sense for gettext.	We comment this out for non-gettext
+   dnl only sense for gettext.  We comment this out for non-gettext
    dnl packages.
    if test "$PACKAGE" = "gettext"; then
      GT_NO="#NO#"
@@ -504,7 +504,7 @@
    fi
    rm -f po/POTFILES
    sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
-	< $srcdir/po/POTFILES.in > po/POTFILES
+        < $srcdir/po/POTFILES.in > po/POTFILES
   ])
 
 
diff -urN gnupg-0.2.9/checks/Makefile.am gnupg-0.2.10/checks/Makefile.am
--- gnupg-0.2.9/checks/Makefile.am	Wed Feb 25 14:33:12 1998
+++ gnupg-0.2.10/checks/Makefile.am	Thu Feb 26 18:01:05 1998
@@ -12,7 +12,7 @@
 
 DATA_FILES = data-500 data-9000 data-32000 data-80000
 
-EXTRA_DIST = $(TESTS) $(TEST_FILES)
+EXTRA_DIST = defs.inc $(TESTS) $(TEST_FILES)
 CLEANFILES = prepared.stamp x y z out err  $(DATA_FILES)
 
 check: prepared.stamp
diff -urN gnupg-0.2.9/checks/Makefile.in gnupg-0.2.10/checks/Makefile.in
--- gnupg-0.2.9/checks/Makefile.in	Thu Feb 26 17:13:37 1998
+++ gnupg-0.2.10/checks/Makefile.in	Fri Feb 27 18:24:08 1998
@@ -103,7 +103,7 @@
 
 DATA_FILES = data-500 data-9000 data-32000 data-80000
 
-EXTRA_DIST = $(TESTS) $(TEST_FILES)
+EXTRA_DIST = defs.inc $(TESTS) $(TEST_FILES)
 CLEANFILES = prepared.stamp x y z out err  $(DATA_FILES)
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
diff -urN gnupg-0.2.9/checks/defs.inc gnupg-0.2.10/checks/defs.inc
--- gnupg-0.2.9/checks/defs.inc	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.10/checks/defs.inc	Wed Feb 25 11:26:53 1998
@@ -0,0 +1,79 @@
+# definitions for the check scripts
+
+#--------------------------------
+#------ constants ---------------
+#--------------------------------
+
+# Note that usrpass1 is also used in Makefile.am
+usrname1="one"
+usrpass1="def"
+usrname2="two"
+usrpass2=""
+plain_files="plain-1 plain-2 plain-3"
+data_files="data-500 data-9000 data-32000 data-80000"
+exp_files=""
+#cleanup_files="x y z"
+
+
+#--------------------------------
+#------ utility functions -------
+#--------------------------------
+
+fatal () {
+    echo "$pgmname: fatal:" $* >&2
+    exit 1;
+}
+
+error () {
+    echo "$pgmname:" $* >&2
+    exit 1
+}
+
+info () {
+    echo "$pgmname:" $* >&2
+}
+
+chdir () {
+    cd $1 || fatal "cannot cd to $1"
+}
+
+#cleanup () {
+#    rm $cleanup_files 2>/dev/null || true
+#    echo "#empty" >./options
+#}
+
+
+#add_cleanup () {
+#    cleanup_files="$cleanup_files $*"
+#}
+
+run_gpg () {
+    if ! eval ../g10/gpg --homedir . $* 2>err ; then
+	cat err >&2
+	echo "(../g10/gpg --homedir . $*) failed" >&2
+	exit 1
+    fi
+    grep -v 'gpg: Good signature from' err || true
+}
+
+run_gpgm () {
+    if ! eval ../g10/gpgm --homedir . $* ; then
+	echo "(../g10/gpgm --homedir . $*) failed" >&2
+	exit 1
+    fi
+}
+
+
+
+set -e
+pgmname=$(basename $0)
+#trap cleanup SIGHUP SIGINT SIGQUIT
+
+[ -z $srcdir ] && fatal "not called from make"
+
+cat <<EOF  >./options
+no-greeting
+no-secmem-warning
+batch
+EOF
+
diff -urN gnupg-0.2.9/cipher/ChangeLog gnupg-0.2.10/cipher/ChangeLog
--- gnupg-0.2.9/cipher/ChangeLog	Thu Feb 26 07:57:46 1998
+++ gnupg-0.2.10/cipher/ChangeLog	Fri Feb 27 16:39:59 1998
@@ -1,3 +1,7 @@
+Fri Feb 27 16:39:34 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* md.c (md_enable): No init if called twice.
+
 Thu Feb 26 07:57:02 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* primegen.c (generate_elg_prime): Changed the progress printing.
diff -urN gnupg-0.2.9/cipher/md.c gnupg-0.2.10/cipher/md.c
--- gnupg-0.2.9/cipher/md.c	Mon Feb 23 13:12:57 1998
+++ gnupg-0.2.10/cipher/md.c	Fri Feb 27 16:40:16 1998
@@ -49,15 +49,18 @@
 md_enable( MD_HANDLE h, int algo )
 {
     if( algo == DIGEST_ALGO_MD5 ) {
-	md5_init( &h->md5 );
+	if( !h->use_md5 )
+	    md5_init( &h->md5 );
 	h->use_md5 = 1;
     }
     else if( algo == DIGEST_ALGO_RMD160 ) {
-	rmd160_init( &h->rmd160 );
+	if( !h->use_rmd160 )
+	    rmd160_init( &h->rmd160 );
 	h->use_rmd160 = 1;
     }
     else if( algo == DIGEST_ALGO_SHA1 ) {
-	sha1_init( &h->sha1 );
+	if( !h->use_sha1 )
+	    sha1_init( &h->sha1 );
 	h->use_sha1 = 1;
     }
     else
diff -urN gnupg-0.2.9/config.h.in gnupg-0.2.10/config.h.in
--- gnupg-0.2.9/config.h.in	Thu Feb 26 16:38:26 1998
+++ gnupg-0.2.10/config.h.in	Fri Feb 27 10:42:25 1998
@@ -77,6 +77,7 @@
 #undef STDC_HEADERS
 
 #undef M_DEBUG
+#undef M_GUARD
 #undef VERSION
 #undef PACKAGE
 #undef G10_LOCALEDIR
diff -urN gnupg-0.2.9/configure gnupg-0.2.10/configure
--- gnupg-0.2.9/configure	Thu Feb 26 16:41:22 1998
+++ gnupg-0.2.10/configure	Fri Feb 27 15:27:14 1998
@@ -12,15 +12,17 @@
 ac_default_prefix=/usr/local
 # Any additions from configure.in:
 ac_help="$ac_help
-  --enable-m-debug	  Enable debugging of memory allocation"
+  --enable-m-debug	  enable debugging of memory allocation"
 ac_help="$ac_help
-  --with-zlib		  link against static zlib"
+  --disable-m-guard       disable memory guard facility"
 ac_help="$ac_help
-  --disable-nls		 do not use Native Language Support"
+  --with-included-zlib    use the zlib code included here"
+ac_help="$ac_help
+  --disable-nls           do not use Native Language Support"
 ac_help="$ac_help
   --with-included-gettext use the GNU gettext library included here"
 ac_help="$ac_help
-  --with-catgets	       use catgets functions if available"
+  --with-catgets          use catgets functions if available"
 
 # Initialize some variables set by options.
 # The variables have the same names as the options, with
@@ -577,30 +579,58 @@
 EOF
 
 
+echo $ac_n "checking whether memory debugging is requested""... $ac_c" 1>&6
+echo "configure:584: checking whether memory debugging is requested" >&5
 # Check whether --enable-m-debug or --disable-m-debug was given.
 if test "${enable_m_debug+set}" = set; then
   enableval="$enable_m_debug"
-  :
+  use_m_debug=$enableval
+else
+  use_m_debug=no
 fi
 
-if test "$enableval" = y || test "$enableval" = yes; then
+echo "$ac_t""$use_m_debug" 1>&6
+if test "$use_m_debug" = yes; then
     cat >> confdefs.h <<\EOF
 #define M_DEBUG 1
 EOF
 
+    use_m_guard=yes
+else
+    echo $ac_n "checking whether memory guard is requested""... $ac_c" 1>&6
+echo "configure:602: checking whether memory guard is requested" >&5
+    # Check whether --enable-m-guard or --disable-m-guard was given.
+if test "${enable_m_guard+set}" = set; then
+  enableval="$enable_m_guard"
+  use_m_guard=$enableval
+else
+  use_m_guard=yes
 fi
 
-# Check whether --with-zlib or --without-zlib was given.
-if test "${with_zlib+set}" = set; then
-  withval="$with_zlib"
-  g10_force_zlib=yes
+    echo "$ac_t""$use_m_guard" 1>&6
+fi
+if test "$use_m_guard" = yes ; then
+    cat >> confdefs.h <<\EOF
+#define M_GUARD 1
+EOF
+
+    CFLAGS="-g -Wall"
 else
-  g10_force_zlib=no 
+    CFLAGS="-O2 -Wall"
 fi
 
 
-CFLAGS="-g -Wall"
+echo $ac_n "checking whether included zlib is requested""... $ac_c" 1>&6
+echo "configure:625: checking whether included zlib is requested" >&5
+# Check whether --with-included-zlib or --without-included-zlib was given.
+if test "${with_included_zlib+set}" = set; then
+  withval="$with_included_zlib"
+  g10_force_zlib=yes
+else
+  g10_force_zlib=no 
+fi
 
+echo "$ac_t""$g10_force_zlib" 1>&6
 
 
 
@@ -631,7 +661,7 @@
 fi
 
 echo $ac_n "checking host system type""... $ac_c" 1>&6
-echo "configure:635: checking host system type" >&5
+echo "configure:665: checking host system type" >&5
 
 host_alias=$host
 case "$host_alias" in
@@ -652,7 +682,7 @@
 echo "$ac_t""$host" 1>&6
 
 echo $ac_n "checking target system type""... $ac_c" 1>&6
-echo "configure:656: checking target system type" >&5
+echo "configure:686: checking target system type" >&5
 
 target_alias=$target
 case "$target_alias" in
@@ -670,7 +700,7 @@
 echo "$ac_t""$target" 1>&6
 
 echo $ac_n "checking build system type""... $ac_c" 1>&6
-echo "configure:674: checking build system type" >&5
+echo "configure:704: checking build system type" >&5
 
 build_alias=$build
 case "$build_alias" in
@@ -693,7 +723,7 @@
   program_prefix=${target_alias}-
 
  echo $ac_n "checking cached information""... $ac_c" 1>&6
-echo "configure:697: checking cached information" >&5
+echo "configure:727: checking cached information" >&5
     wk_hostcheck="$target"
     if eval "test \"`echo '$''{'wk_cv_hostcheck'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -702,18 +732,18 @@
 fi
 
     if test "$wk_cv_hostcheck" != "$wk_hostcheck"; then
-	echo "$ac_t""changed" 1>&6
-	echo "configure: warning: config.cache exists!" 1>&2
-	{ echo "configure: error: you must do 'make distclean' first to compile for
-		 different target or different parameters." 1>&2; exit 1; }
+        echo "$ac_t""changed" 1>&6
+        echo "configure: warning: config.cache exists!" 1>&2
+        { echo "configure: error: you must do 'make distclean' first to compile for
+                 different target or different parameters." 1>&2; exit 1; }
     else
-	echo "$ac_t""ok" 1>&6
+        echo "$ac_t""ok" 1>&6
     fi
   
 
 
 echo $ac_n "checking whether ${MAKE-make} sets \${MAKE}""... $ac_c" 1>&6
-echo "configure:717: checking whether ${MAKE-make} sets \${MAKE}" >&5
+echo "configure:747: checking whether ${MAKE-make} sets \${MAKE}" >&5
 set dummy ${MAKE-make}; ac_make=`echo "$2" | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_prog_make_${ac_make}_set'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -761,7 +791,7 @@
 
 missing_dir=`cd $ac_aux_dir && pwd`
 echo $ac_n "checking for working aclocal""... $ac_c" 1>&6
-echo "configure:765: checking for working aclocal" >&5
+echo "configure:795: checking for working aclocal" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -774,7 +804,7 @@
 fi
 
 echo $ac_n "checking for working autoconf""... $ac_c" 1>&6
-echo "configure:778: checking for working autoconf" >&5
+echo "configure:808: checking for working autoconf" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -787,7 +817,7 @@
 fi
 
 echo $ac_n "checking for working automake""... $ac_c" 1>&6
-echo "configure:791: checking for working automake" >&5
+echo "configure:821: checking for working automake" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -800,7 +830,7 @@
 fi
 
 echo $ac_n "checking for working autoheader""... $ac_c" 1>&6
-echo "configure:804: checking for working autoheader" >&5
+echo "configure:834: checking for working autoheader" >&5
 # Run test in a subshell; some versions of sh will print an error if
 # an executable is not found, even if stderr is redirected.
 # Redirect stdin to placate older versions of autoconf.  Sigh.
@@ -815,7 +845,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:819: checking for $ac_word" >&5
+echo "configure:849: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -844,7 +874,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:848: checking for $ac_word" >&5
+echo "configure:878: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -892,7 +922,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:896: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:926: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -902,11 +932,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 906 "configure"
+#line 936 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:910: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:940: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -926,12 +956,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:930: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:960: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:935: checking whether we are using GNU C" >&5
+echo "configure:965: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -940,7 +970,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:944: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:974: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -955,7 +985,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:959: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:989: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -983,7 +1013,7 @@
 fi
 
 echo $ac_n "checking for POSIXized ISC""... $ac_c" 1>&6
-echo "configure:987: checking for POSIXized ISC" >&5
+echo "configure:1017: checking for POSIXized ISC" >&5
 if test -d /etc/conf/kconfig.d &&
   grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1
 then
@@ -1018,7 +1048,7 @@
 # Extract the first word of "ranlib", so it can be a program name with args.
 set dummy ranlib; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1022: checking for $ac_word" >&5
+echo "configure:1052: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_RANLIB'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1055,7 +1085,7 @@
 # SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
 # ./install, which can be erroneously created by make from ./install.sh.
 echo $ac_n "checking for a BSD compatible install""... $ac_c" 1>&6
-echo "configure:1059: checking for a BSD compatible install" >&5
+echo "configure:1089: checking for a BSD compatible install" >&5
 if test -z "$INSTALL"; then
 if eval "test \"`echo '$''{'ac_cv_path_install'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1107,7 +1137,7 @@
 # Extract the first word of "gcc", so it can be a program name with args.
 set dummy gcc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1111: checking for $ac_word" >&5
+echo "configure:1141: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1136,7 +1166,7 @@
   # Extract the first word of "cc", so it can be a program name with args.
 set dummy cc; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:1140: checking for $ac_word" >&5
+echo "configure:1170: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_CC'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1184,7 +1214,7 @@
 fi
 
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works""... $ac_c" 1>&6
-echo "configure:1188: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
+echo "configure:1218: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) works" >&5
 
 ac_ext=c
 # CFLAGS is not in ac_cpp because -g, -O, etc. are not valid cpp options.
@@ -1194,11 +1224,11 @@
 cross_compiling=$ac_cv_prog_cc_cross
 
 cat > conftest.$ac_ext <<EOF
-#line 1198 "configure"
+#line 1228 "configure"
 #include "confdefs.h"
 main(){return(0);}
 EOF
-if { (eval echo configure:1202: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:1232: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   ac_cv_prog_cc_works=yes
   # If we can't run a trivial program, we are probably using a cross compiler.
   if (./conftest; exit) 2>/dev/null; then
@@ -1218,12 +1248,12 @@
   { echo "configure: error: installation or configuration problem: C compiler cannot create executables." 1>&2; exit 1; }
 fi
 echo $ac_n "checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler""... $ac_c" 1>&6
-echo "configure:1222: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
+echo "configure:1252: checking whether the C compiler ($CC $CFLAGS $LDFLAGS) is a cross-compiler" >&5
 echo "$ac_t""$ac_cv_prog_cc_cross" 1>&6
 cross_compiling=$ac_cv_prog_cc_cross
 
 echo $ac_n "checking whether we are using GNU C""... $ac_c" 1>&6
-echo "configure:1227: checking whether we are using GNU C" >&5
+echo "configure:1257: checking whether we are using GNU C" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_gcc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1232,7 +1262,7 @@
   yes;
 #endif
 EOF
-if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:1236: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
+if { ac_try='${CC-cc} -E conftest.c'; { (eval echo configure:1266: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }; } | egrep yes >/dev/null 2>&1; then
   ac_cv_prog_gcc=yes
 else
   ac_cv_prog_gcc=no
@@ -1247,7 +1277,7 @@
   ac_save_CFLAGS="$CFLAGS"
   CFLAGS=
   echo $ac_n "checking whether ${CC-cc} accepts -g""... $ac_c" 1>&6
-echo "configure:1251: checking whether ${CC-cc} accepts -g" >&5
+echo "configure:1281: checking whether ${CC-cc} accepts -g" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_cc_g'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1275,7 +1305,7 @@
 fi
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:1279: checking how to run the C preprocessor" >&5
+echo "configure:1309: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
   CPP=
@@ -1290,13 +1320,13 @@
   # On the NeXT, cc -E runs the code through the compiler's parser,
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1294 "configure"
+#line 1324 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1300: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1330: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1307,13 +1337,13 @@
   rm -rf conftest*
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1311 "configure"
+#line 1341 "configure"
 #include "confdefs.h"
 #include <assert.h>
 Syntax Error
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1317: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1347: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   :
@@ -1345,12 +1375,12 @@
 
 
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1349: checking for ANSI C header files" >&5
+echo "configure:1379: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1354 "configure"
+#line 1384 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 #include <stdarg.h>
@@ -1358,7 +1388,7 @@
 #include <float.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1362: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1392: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1375,7 +1405,7 @@
 if test $ac_cv_header_stdc = yes; then
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1379 "configure"
+#line 1409 "configure"
 #include "confdefs.h"
 #include <string.h>
 EOF
@@ -1393,7 +1423,7 @@
 if test $ac_cv_header_stdc = yes; then
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1397 "configure"
+#line 1427 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
 EOF
@@ -1414,7 +1444,7 @@
   :
 else
   cat > conftest.$ac_ext <<EOF
-#line 1418 "configure"
+#line 1448 "configure"
 #include "confdefs.h"
 #include <ctype.h>
 #define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
@@ -1425,7 +1455,7 @@
 exit (0); }
 
 EOF
-if { (eval echo configure:1429: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1459: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   :
 else
@@ -1452,17 +1482,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1456: checking for $ac_hdr" >&5
+echo "configure:1486: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1461 "configure"
+#line 1491 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1466: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1496: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -1498,12 +1528,12 @@
 
 
 echo $ac_n "checking for working const""... $ac_c" 1>&6
-echo "configure:1502: checking for working const" >&5
+echo "configure:1532: checking for working const" >&5
 if eval "test \"`echo '$''{'ac_cv_c_const'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1507 "configure"
+#line 1537 "configure"
 #include "confdefs.h"
 
 int main() {
@@ -1552,7 +1582,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:1556: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1586: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_const=yes
 else
@@ -1573,21 +1603,21 @@
 fi
 
 echo $ac_n "checking for inline""... $ac_c" 1>&6
-echo "configure:1577: checking for inline" >&5
+echo "configure:1607: checking for inline" >&5
 if eval "test \"`echo '$''{'ac_cv_c_inline'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   ac_cv_c_inline=no
 for ac_kw in inline __inline__ __inline; do
   cat > conftest.$ac_ext <<EOF
-#line 1584 "configure"
+#line 1614 "configure"
 #include "confdefs.h"
 
 int main() {
 } $ac_kw foo() {
 ; return 0; }
 EOF
-if { (eval echo configure:1591: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1621: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   ac_cv_c_inline=$ac_kw; break
 else
@@ -1613,12 +1643,12 @@
 esac
 
 echo $ac_n "checking for size_t""... $ac_c" 1>&6
-echo "configure:1617: checking for size_t" >&5
+echo "configure:1647: checking for size_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_size_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1622 "configure"
+#line 1652 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -1647,43 +1677,43 @@
 
 
  if test "$cross_compiling" = yes; then
-	echo "configure: warning: cross compiling; assuming little endianess" 1>&2
+        echo "configure: warning: cross compiling; assuming little endianess" 1>&2
     fi
     echo $ac_n "checking endianess""... $ac_c" 1>&6
-echo "configure:1654: checking endianess" >&5
+echo "configure:1684: checking endianess" >&5
     if eval "test \"`echo '$''{'wk_cv_c_endian'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
    wk_cv_c_endian=unknown
-	# See if sys/param.h defines the BYTE_ORDER macro.
-	cat > conftest.$ac_ext <<EOF
-#line 1661 "configure"
+        # See if sys/param.h defines the BYTE_ORDER macro.
+        cat > conftest.$ac_ext <<EOF
+#line 1691 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
-	#include <sys/param.h>
+        #include <sys/param.h>
 int main() {
 
-	#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
-	 bogus endian macros
-	#endif
+        #if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+         bogus endian macros
+        #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1672: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1702: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   # It does; now see whether it defined to BIG_ENDIAN or not.
-	cat > conftest.$ac_ext <<EOF
-#line 1676 "configure"
+        cat > conftest.$ac_ext <<EOF
+#line 1706 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
-	#include <sys/param.h>
+        #include <sys/param.h>
 int main() {
 
-	#if BYTE_ORDER != BIG_ENDIAN
-	 not big endian
-	#endif
+        #if BYTE_ORDER != BIG_ENDIAN
+         not big endian
+        #endif
 ; return 0; }
 EOF
-if { (eval echo configure:1687: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1717: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_c_endian=big
 else
@@ -1698,26 +1728,26 @@
   cat conftest.$ac_ext >&5
 fi
 rm -f conftest*
-	if test "$wk_cv_c_endian" = unknown; then
-	    if test "$cross_compiling" = yes; then
+        if test "$wk_cv_c_endian" = unknown; then
+            if test "$cross_compiling" = yes; then
   wk_cv_c_endian=little
-	    
+            
 else
   cat > conftest.$ac_ext <<EOF
-#line 1708 "configure"
+#line 1738 "configure"
 #include "confdefs.h"
 main () {
-	      /* Are we little or big endian?  From Harbison&Steele.  */
-	      union
-	      {
-		long l;
-		char c[sizeof (long)];
-	      } u;
-	      u.l = 1;
-	      exit (u.c[sizeof (long) - 1] == 1);
-	      }
+              /* Are we little or big endian?  From Harbison&Steele.  */
+              union
+              {
+                long l;
+                char c[sizeof (long)];
+              } u;
+              u.l = 1;
+              exit (u.c[sizeof (long) - 1] == 1);
+              }
 EOF
-if { (eval echo configure:1721: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1751: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   wk_cv_c_endian=little
 else
@@ -1729,7 +1759,7 @@
 rm -fr conftest*
 fi
 
-	fi
+        fi
       
 fi
 
@@ -1749,12 +1779,12 @@
 
 
  echo $ac_n "checking for byte typedef""... $ac_c" 1>&6
-echo "configure:1753: checking for byte typedef" >&5
+echo "configure:1783: checking for byte typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_byte'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1758 "configure"
+#line 1788 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1765,7 +1795,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1769: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1799: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_byte=yes
 else
@@ -1779,19 +1809,19 @@
 
     echo "$ac_t""$wk_cv_typedef_byte" 1>&6
     if test "$wk_cv_typedef_byte" = yes; then
-	cat >> confdefs.h <<\EOF
+        cat >> confdefs.h <<\EOF
 #define HAVE_BYTE_TYPEDEF 1
 EOF
 
     fi
   
  echo $ac_n "checking for ushort typedef""... $ac_c" 1>&6
-echo "configure:1790: checking for ushort typedef" >&5
+echo "configure:1820: checking for ushort typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ushort'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1795 "configure"
+#line 1825 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1802,7 +1832,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1806: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1836: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ushort=yes
 else
@@ -1816,19 +1846,19 @@
 
     echo "$ac_t""$wk_cv_typedef_ushort" 1>&6
     if test "$wk_cv_typedef_ushort" = yes; then
-	cat >> confdefs.h <<\EOF
+        cat >> confdefs.h <<\EOF
 #define HAVE_USHORT_TYPEDEF 1
 EOF
 
     fi
   
  echo $ac_n "checking for ulong typedef""... $ac_c" 1>&6
-echo "configure:1827: checking for ulong typedef" >&5
+echo "configure:1857: checking for ulong typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_ulong'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1832 "configure"
+#line 1862 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1839,7 +1869,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1843: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1873: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_ulong=yes
 else
@@ -1853,19 +1883,19 @@
 
     echo "$ac_t""$wk_cv_typedef_ulong" 1>&6
     if test "$wk_cv_typedef_ulong" = yes; then
-	cat >> confdefs.h <<\EOF
+        cat >> confdefs.h <<\EOF
 #define HAVE_ULONG_TYPEDEF 1
 EOF
 
     fi
   
  echo $ac_n "checking for u16 typedef""... $ac_c" 1>&6
-echo "configure:1864: checking for u16 typedef" >&5
+echo "configure:1894: checking for u16 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u16'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1869 "configure"
+#line 1899 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1876,7 +1906,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1880: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1910: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u16=yes
 else
@@ -1890,19 +1920,19 @@
 
     echo "$ac_t""$wk_cv_typedef_u16" 1>&6
     if test "$wk_cv_typedef_u16" = yes; then
-	cat >> confdefs.h <<\EOF
+        cat >> confdefs.h <<\EOF
 #define HAVE_U16_TYPEDEF 1
 EOF
 
     fi
   
  echo $ac_n "checking for u32 typedef""... $ac_c" 1>&6
-echo "configure:1901: checking for u32 typedef" >&5
+echo "configure:1931: checking for u32 typedef" >&5
     if eval "test \"`echo '$''{'wk_cv_typedef_u32'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1906 "configure"
+#line 1936 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
     #include <sys/types.h>
@@ -1913,7 +1943,7 @@
     
 ; return 0; }
 EOF
-if { (eval echo configure:1917: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
+if { (eval echo configure:1947: \"$ac_compile\") 1>&5; (eval $ac_compile) 2>&5; }; then
   rm -rf conftest*
   wk_cv_typedef_u32=yes
 else
@@ -1927,7 +1957,7 @@
 
     echo "$ac_t""$wk_cv_typedef_u32" 1>&6
     if test "$wk_cv_typedef_u32" = yes; then
-	cat >> confdefs.h <<\EOF
+        cat >> confdefs.h <<\EOF
 #define HAVE_U32_TYPEDEF 1
 EOF
 
@@ -1935,7 +1965,7 @@
   
 
 echo $ac_n "checking size of unsigned short""... $ac_c" 1>&6
-echo "configure:1939: checking size of unsigned short" >&5
+echo "configure:1969: checking size of unsigned short" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_short'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1943,7 +1973,7 @@
   ac_cv_sizeof_unsigned_short=2
 else
   cat > conftest.$ac_ext <<EOF
-#line 1947 "configure"
+#line 1977 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -1954,7 +1984,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:1958: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1988: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_short=`cat conftestval`
 else
@@ -1974,7 +2004,7 @@
 
 
 echo $ac_n "checking size of unsigned int""... $ac_c" 1>&6
-echo "configure:1978: checking size of unsigned int" >&5
+echo "configure:2008: checking size of unsigned int" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -1982,7 +2012,7 @@
   ac_cv_sizeof_unsigned_int=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 1986 "configure"
+#line 2016 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -1993,7 +2023,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:1997: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2027: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_int=`cat conftestval`
 else
@@ -2013,7 +2043,7 @@
 
 
 echo $ac_n "checking size of unsigned long""... $ac_c" 1>&6
-echo "configure:2017: checking size of unsigned long" >&5
+echo "configure:2047: checking size of unsigned long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_unsigned_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2021,7 +2051,7 @@
   ac_cv_sizeof_unsigned_long=4
 else
   cat > conftest.$ac_ext <<EOF
-#line 2025 "configure"
+#line 2055 "configure"
 #include "confdefs.h"
 #include <stdio.h>
 main()
@@ -2032,7 +2062,7 @@
   exit(0);
 }
 EOF
-if { (eval echo configure:2036: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2066: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_unsigned_long=`cat conftestval`
 else
@@ -2061,12 +2091,12 @@
 
 
 echo $ac_n "checking for vprintf""... $ac_c" 1>&6
-echo "configure:2065: checking for vprintf" >&5
+echo "configure:2095: checking for vprintf" >&5
 if eval "test \"`echo '$''{'ac_cv_func_vprintf'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2070 "configure"
+#line 2100 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char vprintf(); below.  */
@@ -2089,7 +2119,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2093: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2123: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_vprintf=yes"
 else
@@ -2113,12 +2143,12 @@
 
 if test "$ac_cv_func_vprintf" != yes; then
 echo $ac_n "checking for _doprnt""... $ac_c" 1>&6
-echo "configure:2117: checking for _doprnt" >&5
+echo "configure:2147: checking for _doprnt" >&5
 if eval "test \"`echo '$''{'ac_cv_func__doprnt'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2122 "configure"
+#line 2152 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char _doprnt(); below.  */
@@ -2141,7 +2171,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2145: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2175: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func__doprnt=yes"
 else
@@ -2168,12 +2198,12 @@
 for ac_func in strerror stpcpy strlwr tcgetattr rand strtoul mlock mmap
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2172: checking for $ac_func" >&5
+echo "configure:2202: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2177 "configure"
+#line 2207 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2196,7 +2226,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2200: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2230: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2225,7 +2255,7 @@
 
 
 echo $ac_n "checking for random device""... $ac_c" 1>&6
-echo "configure:2229: checking for random device" >&5
+echo "configure:2259: checking for random device" >&5
 if eval "test \"`echo '$''{'ac_cv_have_dev_random'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2243,15 +2273,15 @@
 
 
 echo $ac_n "checking for mpi assembler functions""... $ac_c" 1>&6
-echo "configure:2247: checking for mpi assembler functions" >&5
+echo "configure:2277: checking for mpi assembler functions" >&5
 if test -f $srcdir/mpi/config.links ; then
     . $srcdir/mpi/config.links
      if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$mpi_ln_src"
-	wk_link_files_dst="$mpi_ln_dst"
+        wk_link_files_src="$mpi_ln_src"
+        wk_link_files_dst="$mpi_ln_dst"
     else
-	wk_link_files_src="$wk_link_files_src $mpi_ln_src"
-	wk_link_files_dst="$wk_link_files_dst $mpi_ln_dst"
+        wk_link_files_src="$wk_link_files_src $mpi_ln_src"
+        wk_link_files_dst="$wk_link_files_dst $mpi_ln_dst"
     fi
   
     ac_cv_mpi_extra_asm_modules="$mpi_extra_modules"
@@ -2286,19 +2316,19 @@
   ENABLE_LOCAL_ZLIB_FALSE=
 fi
      if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zlib.h"
-	wk_link_files_dst="zlib.h "
+        wk_link_files_src="zlib/zlib.h"
+        wk_link_files_dst="zlib.h "
     else
-	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
-	wk_link_files_dst="$wk_link_files_dst zlib.h "
+        wk_link_files_src="$wk_link_files_src zlib/zlib.h"
+        wk_link_files_dst="$wk_link_files_dst zlib.h "
     fi
   
      if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zconf.h"
-	wk_link_files_dst="zconf.h "
+        wk_link_files_src="zlib/zconf.h"
+        wk_link_files_dst="zconf.h "
     else
-	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
-	wk_link_files_dst="$wk_link_files_dst zconf.h "
+        wk_link_files_src="$wk_link_files_src zlib/zconf.h"
+        wk_link_files_dst="$wk_link_files_dst zconf.h "
     fi
   
 else
@@ -2306,17 +2336,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2310: checking for $ac_hdr" >&5
+echo "configure:2340: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2315 "configure"
+#line 2345 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2320: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2350: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2366,19 +2396,19 @@
   ENABLE_LOCAL_ZLIB_FALSE=
 fi
      if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zlib.h"
-	wk_link_files_dst="zlib.h "
+        wk_link_files_src="zlib/zlib.h"
+        wk_link_files_dst="zlib.h "
     else
-	wk_link_files_src="$wk_link_files_src zlib/zlib.h"
-	wk_link_files_dst="$wk_link_files_dst zlib.h "
+        wk_link_files_src="$wk_link_files_src zlib/zlib.h"
+        wk_link_files_dst="$wk_link_files_dst zlib.h "
     fi
   
      if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="zlib/zconf.h"
-	wk_link_files_dst="zconf.h "
+        wk_link_files_src="zlib/zconf.h"
+        wk_link_files_dst="zconf.h "
     else
-	wk_link_files_src="$wk_link_files_src zlib/zconf.h"
-	wk_link_files_dst="$wk_link_files_dst zconf.h "
+        wk_link_files_src="$wk_link_files_src zlib/zconf.h"
+        wk_link_files_dst="$wk_link_files_dst zconf.h "
     fi
   
 fi
@@ -2389,7 +2419,7 @@
 CIPHER_EXTRA_OBJS=""
 CIPHER_EXTRA_DIST=""
 echo $ac_n "checking for extra cipher modules""... $ac_c" 1>&6
-echo "configure:2393: checking for extra cipher modules" >&5
+echo "configure:2423: checking for extra cipher modules" >&5
 if eval "test \"`echo '$''{'ac_cv_have_rsa_cipher'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2410,12 +2440,12 @@
 
 
 echo $ac_n "checking for off_t""... $ac_c" 1>&6
-echo "configure:2414: checking for off_t" >&5
+echo "configure:2444: checking for off_t" >&5
 if eval "test \"`echo '$''{'ac_cv_type_off_t'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2419 "configure"
+#line 2449 "configure"
 #include "confdefs.h"
 #include <sys/types.h>
 #if STDC_HEADERS
@@ -2445,19 +2475,19 @@
 # The Ultrix 4.2 mips builtin alloca declared by alloca.h only works
 # for constant arguments.  Useless!
 echo $ac_n "checking for working alloca.h""... $ac_c" 1>&6
-echo "configure:2449: checking for working alloca.h" >&5
+echo "configure:2479: checking for working alloca.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_alloca_h'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2454 "configure"
+#line 2484 "configure"
 #include "confdefs.h"
 #include <alloca.h>
 int main() {
 char *p = alloca(2 * sizeof(int));
 ; return 0; }
 EOF
-if { (eval echo configure:2461: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2491: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_header_alloca_h=yes
 else
@@ -2478,12 +2508,12 @@
 fi
 
 echo $ac_n "checking for alloca""... $ac_c" 1>&6
-echo "configure:2482: checking for alloca" >&5
+echo "configure:2512: checking for alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_func_alloca_works'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2487 "configure"
+#line 2517 "configure"
 #include "confdefs.h"
 
 #ifdef __GNUC__
@@ -2506,7 +2536,7 @@
 char *p = (char *) alloca(1);
 ; return 0; }
 EOF
-if { (eval echo configure:2510: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2540: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   ac_cv_func_alloca_works=yes
 else
@@ -2538,12 +2568,12 @@
 
 
 echo $ac_n "checking whether alloca needs Cray hooks""... $ac_c" 1>&6
-echo "configure:2542: checking whether alloca needs Cray hooks" >&5
+echo "configure:2572: checking whether alloca needs Cray hooks" >&5
 if eval "test \"`echo '$''{'ac_cv_os_cray'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2547 "configure"
+#line 2577 "configure"
 #include "confdefs.h"
 #if defined(CRAY) && ! defined(CRAY2)
 webecray
@@ -2568,12 +2598,12 @@
 if test $ac_cv_os_cray = yes; then
 for ac_func in _getb67 GETB67 getb67; do
   echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2572: checking for $ac_func" >&5
+echo "configure:2602: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2577 "configure"
+#line 2607 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2596,7 +2626,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2600: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2630: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2623,7 +2653,7 @@
 fi
 
 echo $ac_n "checking stack direction for C alloca""... $ac_c" 1>&6
-echo "configure:2627: checking stack direction for C alloca" >&5
+echo "configure:2657: checking stack direction for C alloca" >&5
 if eval "test \"`echo '$''{'ac_cv_c_stack_direction'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2631,7 +2661,7 @@
   ac_cv_c_stack_direction=0
 else
   cat > conftest.$ac_ext <<EOF
-#line 2635 "configure"
+#line 2665 "configure"
 #include "confdefs.h"
 find_stack_direction ()
 {
@@ -2650,7 +2680,7 @@
   exit (find_stack_direction() < 0);
 }
 EOF
-if { (eval echo configure:2654: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2684: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_c_stack_direction=1
 else
@@ -2675,17 +2705,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2679: checking for $ac_hdr" >&5
+echo "configure:2709: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2684 "configure"
+#line 2714 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2689: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2719: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2714,12 +2744,12 @@
 for ac_func in getpagesize
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2718: checking for $ac_func" >&5
+echo "configure:2748: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2723 "configure"
+#line 2753 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -2742,7 +2772,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:2746: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:2776: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -2767,7 +2797,7 @@
 done
 
 echo $ac_n "checking for working mmap""... $ac_c" 1>&6
-echo "configure:2771: checking for working mmap" >&5
+echo "configure:2801: checking for working mmap" >&5
 if eval "test \"`echo '$''{'ac_cv_func_mmap_fixed_mapped'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -2775,7 +2805,7 @@
   ac_cv_func_mmap_fixed_mapped=no
 else
   cat > conftest.$ac_ext <<EOF
-#line 2779 "configure"
+#line 2809 "configure"
 #include "confdefs.h"
 
 /* Thanks to Mike Haertel and Jim Avera for this test.
@@ -2915,7 +2945,7 @@
 }
 
 EOF
-if { (eval echo configure:2919: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:2949: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest && (./conftest; exit) 2>/dev/null
 then
   ac_cv_func_mmap_fixed_mapped=yes
 else
@@ -2943,17 +2973,17 @@
 do
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:2947: checking for $ac_hdr" >&5
+echo "configure:2977: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2952 "configure"
+#line 2982 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:2957: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:2987: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -2983,12 +3013,12 @@
 __argz_count __argz_stringify __argz_next
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:2987: checking for $ac_func" >&5
+echo "configure:3017: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 2992 "configure"
+#line 3022 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3011,7 +3041,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3015: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3045: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3040,12 +3070,12 @@
      for ac_func in stpcpy
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3044: checking for $ac_func" >&5
+echo "configure:3074: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3049 "configure"
+#line 3079 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3068,7 +3098,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3072: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3102: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3102,19 +3132,19 @@
 
    if test $ac_cv_header_locale_h = yes; then
     echo $ac_n "checking for LC_MESSAGES""... $ac_c" 1>&6
-echo "configure:3106: checking for LC_MESSAGES" >&5
+echo "configure:3136: checking for LC_MESSAGES" >&5
 if eval "test \"`echo '$''{'am_cv_val_LC_MESSAGES'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3111 "configure"
+#line 3141 "configure"
 #include "confdefs.h"
 #include <locale.h>
 int main() {
 return LC_MESSAGES
 ; return 0; }
 EOF
-if { (eval echo configure:3118: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3148: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   am_cv_val_LC_MESSAGES=yes
 else
@@ -3135,7 +3165,7 @@
     fi
   fi
    echo $ac_n "checking whether NLS is requested""... $ac_c" 1>&6
-echo "configure:3139: checking whether NLS is requested" >&5
+echo "configure:3169: checking whether NLS is requested" >&5
         # Check whether --enable-nls or --disable-nls was given.
 if test "${enable_nls+set}" = set; then
   enableval="$enable_nls"
@@ -3155,7 +3185,7 @@
 EOF
 
       echo $ac_n "checking whether included gettext is requested""... $ac_c" 1>&6
-echo "configure:3159: checking whether included gettext is requested" >&5
+echo "configure:3189: checking whether included gettext is requested" >&5
       # Check whether --with-included-gettext or --without-included-gettext was given.
 if test "${with_included_gettext+set}" = set; then
   withval="$with_included_gettext"
@@ -3168,23 +3198,23 @@
 
       nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
       if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
-					nls_cv_header_intl=
-	nls_cv_header_libgt=
-	CATOBJEXT=NONE
+                                        nls_cv_header_intl=
+        nls_cv_header_libgt=
+        CATOBJEXT=NONE
 
-	ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
+        ac_safe=`echo "libintl.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for libintl.h""... $ac_c" 1>&6
-echo "configure:3178: checking for libintl.h" >&5
+echo "configure:3208: checking for libintl.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3183 "configure"
+#line 3213 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3188: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3218: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -3201,19 +3231,19 @@
 if eval "test \"`echo '$ac_cv_header_'$ac_safe`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libc""... $ac_c" 1>&6
-echo "configure:3205: checking for gettext in libc" >&5
+echo "configure:3235: checking for gettext in libc" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3210 "configure"
+#line 3240 "configure"
 #include "confdefs.h"
 #include <libintl.h>
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3217: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3247: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libc=yes
 else
@@ -3227,9 +3257,9 @@
 
 echo "$ac_t""$gt_cv_func_gettext_libc" 1>&6
 
-	   if test "$gt_cv_func_gettext_libc" != "yes"; then
-	     echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
-echo "configure:3233: checking for bindtextdomain in -lintl" >&5
+           if test "$gt_cv_func_gettext_libc" != "yes"; then
+             echo $ac_n "checking for bindtextdomain in -lintl""... $ac_c" 1>&6
+echo "configure:3263: checking for bindtextdomain in -lintl" >&5
 ac_lib_var=`echo intl'_'bindtextdomain | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3237,7 +3267,7 @@
   ac_save_LIBS="$LIBS"
 LIBS="-lintl  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3241 "configure"
+#line 3271 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
 /* We use char because int might match the return type of a gcc2
@@ -3248,7 +3278,7 @@
 bindtextdomain()
 ; return 0; }
 EOF
-if { (eval echo configure:3252: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3282: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3264,19 +3294,19 @@
 if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
   echo "$ac_t""yes" 1>&6
   echo $ac_n "checking for gettext in libintl""... $ac_c" 1>&6
-echo "configure:3268: checking for gettext in libintl" >&5
+echo "configure:3298: checking for gettext in libintl" >&5
 if eval "test \"`echo '$''{'gt_cv_func_gettext_libintl'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3273 "configure"
+#line 3303 "configure"
 #include "confdefs.h"
 
 int main() {
 return (int) gettext ("")
 ; return 0; }
 EOF
-if { (eval echo configure:3280: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3310: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   gt_cv_func_gettext_libintl=yes
 else
@@ -3293,18 +3323,18 @@
   echo "$ac_t""no" 1>&6
 fi
 
-	   fi
+           fi
 
-	   if test "$gt_cv_func_gettext_libc" = "yes" \
-	      || test "$gt_cv_func_gettext_libintl" = "yes"; then
-	      cat >> confdefs.h <<\EOF
+           if test "$gt_cv_func_gettext_libc" = "yes" \
+              || test "$gt_cv_func_gettext_libintl" = "yes"; then
+              cat >> confdefs.h <<\EOF
 #define HAVE_GETTEXT 1
 EOF
 
-	      # Extract the first word of "msgfmt", so it can be a program name with args.
+              # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3308: checking for $ac_word" >&5
+echo "configure:3338: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3318,8 +3348,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3334,16 +3364,16 @@
 else
   echo "$ac_t""no" 1>&6
 fi
-	      if test "$MSGFMT" != "no"; then
-		for ac_func in dcgettext
+              if test "$MSGFMT" != "no"; then
+                for ac_func in dcgettext
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
-echo "configure:3342: checking for $ac_func" >&5
+echo "configure:3372: checking for $ac_func" >&5
 if eval "test \"`echo '$''{'ac_cv_func_$ac_func'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3347 "configure"
+#line 3377 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char $ac_func(); below.  */
@@ -3366,7 +3396,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3370: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3400: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_$ac_func=yes"
 else
@@ -3390,10 +3420,10 @@
 fi
 done
 
-		# Extract the first word of "gmsgfmt", so it can be a program name with args.
+                # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3397: checking for $ac_word" >&5
+echo "configure:3427: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3422,10 +3452,10 @@
   echo "$ac_t""no" 1>&6
 fi
 
-		# Extract the first word of "xgettext", so it can be a program name with args.
+                # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3429: checking for $ac_word" >&5
+echo "configure:3459: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3439,8 +3469,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3456,40 +3486,40 @@
   echo "$ac_t""no" 1>&6
 fi
 
-		cat > conftest.$ac_ext <<EOF
-#line 3461 "configure"
+                cat > conftest.$ac_ext <<EOF
+#line 3491 "configure"
 #include "confdefs.h"
 
 int main() {
 extern int _nl_msg_cat_cntr;
-			       return _nl_msg_cat_cntr
+                               return _nl_msg_cat_cntr
 ; return 0; }
 EOF
-if { (eval echo configure:3469: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3499: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   CATOBJEXT=.gmo
-		   DATADIRNAME=share
+                   DATADIRNAME=share
 else
   echo "configure: failed program was:" >&5
   cat conftest.$ac_ext >&5
   rm -rf conftest*
   CATOBJEXT=.mo
-		   DATADIRNAME=lib
+                   DATADIRNAME=lib
 fi
 rm -f conftest*
-		INSTOBJEXT=.mo
-	      fi
-	    fi
-	
+                INSTOBJEXT=.mo
+              fi
+            fi
+        
 else
   echo "$ac_t""no" 1>&6
 fi
 
 
-	if test "$CATOBJEXT" = "NONE"; then
-	  echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
-echo "configure:3492: checking whether catgets can be used" >&5
-	  # Check whether --with-catgets or --without-catgets was given.
+        if test "$CATOBJEXT" = "NONE"; then
+          echo $ac_n "checking whether catgets can be used""... $ac_c" 1>&6
+echo "configure:3522: checking whether catgets can be used" >&5
+          # Check whether --with-catgets or --without-catgets was given.
 if test "${with_catgets+set}" = set; then
   withval="$with_catgets"
   nls_cv_use_catgets=$withval
@@ -3497,11 +3527,11 @@
   nls_cv_use_catgets=no
 fi
 
-	  echo "$ac_t""$nls_cv_use_catgets" 1>&6
+          echo "$ac_t""$nls_cv_use_catgets" 1>&6
 
-	  if test "$nls_cv_use_catgets" = "yes"; then
-	    	    echo $ac_n "checking for main in -li""... $ac_c" 1>&6
-echo "configure:3505: checking for main in -li" >&5
+          if test "$nls_cv_use_catgets" = "yes"; then
+                        echo $ac_n "checking for main in -li""... $ac_c" 1>&6
+echo "configure:3535: checking for main in -li" >&5
 ac_lib_var=`echo i'_'main | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3509,14 +3539,14 @@
   ac_save_LIBS="$LIBS"
 LIBS="-li  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 3513 "configure"
+#line 3543 "configure"
 #include "confdefs.h"
 
 int main() {
 main()
 ; return 0; }
 EOF
-if { (eval echo configure:3520: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3550: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
 else
@@ -3543,13 +3573,13 @@
   echo "$ac_t""no" 1>&6
 fi
 
-	    echo $ac_n "checking for catgets""... $ac_c" 1>&6
-echo "configure:3548: checking for catgets" >&5
+            echo $ac_n "checking for catgets""... $ac_c" 1>&6
+echo "configure:3578: checking for catgets" >&5
 if eval "test \"`echo '$''{'ac_cv_func_catgets'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3553 "configure"
+#line 3583 "configure"
 #include "confdefs.h"
 /* System header to define __stub macros and hopefully few prototypes,
     which can conflict with char catgets(); below.  */
@@ -3572,7 +3602,7 @@
 
 ; return 0; }
 EOF
-if { (eval echo configure:3576: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
+if { (eval echo configure:3606: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest; then
   rm -rf conftest*
   eval "ac_cv_func_catgets=yes"
 else
@@ -3590,11 +3620,11 @@
 #define HAVE_CATGETS 1
 EOF
 
-	       INTLOBJS="\$(CATOBJS)"
-	       # Extract the first word of "gencat", so it can be a program name with args.
+               INTLOBJS="\$(CATOBJS)"
+               # Extract the first word of "gencat", so it can be a program name with args.
 set dummy gencat; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3598: checking for $ac_word" >&5
+echo "configure:3628: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GENCAT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3622,11 +3652,11 @@
 else
   echo "$ac_t""no" 1>&6
 fi
-	       if test "$GENCAT" != "no"; then
-		 # Extract the first word of "gmsgfmt", so it can be a program name with args.
+               if test "$GENCAT" != "no"; then
+                 # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3630: checking for $ac_word" >&5
+echo "configure:3660: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3655,11 +3685,11 @@
   echo "$ac_t""no" 1>&6
 fi
 
-		 if test "$GMSGFMT" = "no"; then
-		   # Extract the first word of "msgfmt", so it can be a program name with args.
+                 if test "$GMSGFMT" = "no"; then
+                   # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3663: checking for $ac_word" >&5
+echo "configure:3693: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3673,8 +3703,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_GMSGFMT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3690,11 +3720,11 @@
   echo "$ac_t""no" 1>&6
 fi
 
-		 fi
-		 # Extract the first word of "xgettext", so it can be a program name with args.
+                 fi
+                 # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3698: checking for $ac_word" >&5
+echo "configure:3728: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3708,8 +3738,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3725,34 +3755,34 @@
   echo "$ac_t""no" 1>&6
 fi
 
-		 USE_INCLUDED_LIBINTL=yes
-		 CATOBJEXT=.cat
-		 INSTOBJEXT=.cat
-		 DATADIRNAME=lib
-		 INTLDEPS='$(top_builddir)/intl/libintl.a'
-		 INTLLIBS=$INTLDEPS
-		 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-		 nls_cv_header_intl=intl/libintl.h
-		 nls_cv_header_libgt=intl/libgettext.h
-	       fi
+                 USE_INCLUDED_LIBINTL=yes
+                 CATOBJEXT=.cat
+                 INSTOBJEXT=.cat
+                 DATADIRNAME=lib
+                 INTLDEPS='$(top_builddir)/intl/libintl.a'
+                 INTLLIBS=$INTLDEPS
+                 LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+                 nls_cv_header_intl=intl/libintl.h
+                 nls_cv_header_libgt=intl/libgettext.h
+               fi
 else
   echo "$ac_t""no" 1>&6
 fi
 
-	  fi
-	fi
-
-	if test "$CATOBJEXT" = "NONE"; then
-	  	  	  nls_cv_use_gnu_gettext=yes
-	fi
+          fi
+        fi
+
+        if test "$CATOBJEXT" = "NONE"; then
+                              nls_cv_use_gnu_gettext=yes
+        fi
       fi
 
       if test "$nls_cv_use_gnu_gettext" = "yes"; then
-		INTLOBJS="\$(GETTOBJS)"
-	# Extract the first word of "msgfmt", so it can be a program name with args.
+                INTLOBJS="\$(GETTOBJS)"
+        # Extract the first word of "msgfmt", so it can be a program name with args.
 set dummy msgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3756: checking for $ac_word" >&5
+echo "configure:3786: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_MSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3766,8 +3796,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep 'dv '`"; then
-	ac_cv_path_MSGFMT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_MSGFMT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3783,10 +3813,10 @@
   echo "$ac_t""no" 1>&6
 fi
 
-	# Extract the first word of "gmsgfmt", so it can be a program name with args.
+        # Extract the first word of "gmsgfmt", so it can be a program name with args.
 set dummy gmsgfmt; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3790: checking for $ac_word" >&5
+echo "configure:3820: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_GMSGFMT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3815,10 +3845,10 @@
   echo "$ac_t""no" 1>&6
 fi
 
-	# Extract the first word of "xgettext", so it can be a program name with args.
+        # Extract the first word of "xgettext", so it can be a program name with args.
 set dummy xgettext; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3822: checking for $ac_word" >&5
+echo "configure:3852: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_XGETTEXT'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
@@ -3832,8 +3862,8 @@
     test -z "$ac_dir" && ac_dir=.
     if test -f $ac_dir/$ac_word; then
       if test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"; then
-	ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
-	break
+        ac_cv_path_XGETTEXT="$ac_dir/$ac_word"
+        break
       fi
     fi
   done
@@ -3849,25 +3879,25 @@
   echo "$ac_t""no" 1>&6
 fi
 
-	
-	USE_INCLUDED_LIBINTL=yes
-	CATOBJEXT=.gmo
-	INSTOBJEXT=.mo
-	DATADIRNAME=share
-	INTLDEPS='$(top_builddir)/intl/libintl.a'
-	INTLLIBS=$INTLDEPS
-	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
-	nls_cv_header_intl=intl/libintl.h
-	nls_cv_header_libgt=intl/libgettext.h
+        
+        USE_INCLUDED_LIBINTL=yes
+        CATOBJEXT=.gmo
+        INSTOBJEXT=.mo
+        DATADIRNAME=share
+        INTLDEPS='$(top_builddir)/intl/libintl.a'
+        INTLLIBS=$INTLDEPS
+        LIBS=`echo $LIBS | sed -e 's/-lintl//'`
+        nls_cv_header_intl=intl/libintl.h
+        nls_cv_header_libgt=intl/libgettext.h
       fi
 
             if test "$XGETTEXT" != ":"; then
-			if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
-	  : ;
-	else
-	  echo "$ac_t""found xgettext programs is not GNU xgettext; ignore it" 1>&6
-	  XGETTEXT=":"
-	fi
+                        if $XGETTEXT --omit-header /dev/null 2> /dev/null; then
+          : ;
+        else
+          echo "$ac_t""found xgettext programs is not GNU xgettext; ignore it" 1>&6
+          XGETTEXT=":"
+        fi
       fi
 
       # We need to process the po/ directory.
@@ -3908,12 +3938,12 @@
        LINGUAS=
      else
        echo $ac_n "checking for catalogs to be installed""... $ac_c" 1>&6
-echo "configure:3912: checking for catalogs to be installed" >&5
+echo "configure:3942: checking for catalogs to be installed" >&5
        NEW_LINGUAS=
        for lang in ${LINGUAS=$ALL_LINGUAS}; do
-	 case "$ALL_LINGUAS" in
-	  *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
-	 esac
+         case "$ALL_LINGUAS" in
+          *$lang*) NEW_LINGUAS="$NEW_LINGUAS $lang" ;;
+         esac
        done
        LINGUAS=$NEW_LINGUAS
        echo "$ac_t""$LINGUAS" 1>&6
@@ -3936,17 +3966,17 @@
    if test "$CATOBJEXT" = ".cat"; then
      ac_safe=`echo "linux/version.h" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for linux/version.h""... $ac_c" 1>&6
-echo "configure:3940: checking for linux/version.h" >&5
+echo "configure:3970: checking for linux/version.h" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 3945 "configure"
+#line 3975 "configure"
 #include "confdefs.h"
 #include <linux/version.h>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:3950: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:3980: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out`
 if test -z "$ac_err"; then
   rm -rf conftest*
@@ -4008,14 +4038,14 @@
    fi
    rm -f po/POTFILES
    sed -e "/^#/d" -e "/^\$/d" -e "s,.*, $posrcprefix& \\\\," -e "\$s/\(.*\) \\\\/\1/" \
-	< $srcdir/po/POTFILES.in > po/POTFILES
+        < $srcdir/po/POTFILES.in > po/POTFILES
   
  if test "x$wk_link_files_src" = "x"; then
-	wk_link_files_src="$nls_cv_header_libgt"
-	wk_link_files_dst="$nls_cv_header_intl "
+        wk_link_files_src="$nls_cv_header_libgt"
+        wk_link_files_dst="$nls_cv_header_intl "
     else
-	wk_link_files_src="$wk_link_files_src $nls_cv_header_libgt"
-	wk_link_files_dst="$wk_link_files_dst $nls_cv_header_intl "
+        wk_link_files_src="$wk_link_files_src $nls_cv_header_libgt"
+        wk_link_files_dst="$wk_link_files_dst $nls_cv_header_intl "
     fi
   
 
diff -urN gnupg-0.2.9/configure.in gnupg-0.2.10/configure.in
--- gnupg-0.2.9/configure.in	Thu Feb 26 16:40:23 1998
+++ gnupg-0.2.10/configure.in	Fri Feb 27 13:40:41 1998
@@ -27,18 +27,34 @@
 AC_DEFINE_UNQUOTED(VERSION, "$VERSION")
 AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE")
 
+AC_MSG_CHECKING([whether memory debugging is requested])
 AC_ARG_ENABLE(m-debug,
-[  --enable-m-debug	  Enable debugging of memory allocation])
-if test "$enableval" = y || test "$enableval" = yes; then
+[  --enable-m-debug	  enable debugging of memory allocation],
+use_m_debug=$enableval, use_m_debug=no)
+AC_MSG_RESULT($use_m_debug)
+if test "$use_m_debug" = yes; then
     AC_DEFINE(M_DEBUG)
+    use_m_guard=yes
+else
+    AC_MSG_CHECKING([whether memory guard is requested])
+    AC_ARG_ENABLE(m-guard,
+    [  --disable-m-guard       disable memory guard facility],
+    use_m_guard=$enableval, use_m_guard=yes)
+    AC_MSG_RESULT($use_m_guard)
+fi
+if test "$use_m_guard" = yes ; then
+    AC_DEFINE(M_GUARD)
+    CFLAGS="-g -Wall"
+else
+    CFLAGS="-O2 -Wall"
 fi
 
-AC_ARG_WITH(zlib,
-[  --with-zlib		  link against static zlib],
-[g10_force_zlib=yes], [g10_force_zlib=no] )
-
-CFLAGS="-g -Wall"
 
+AC_MSG_CHECKING([whether included zlib is requested])
+AC_ARG_WITH(included-zlib,
+    [  --with-included-zlib    use the zlib code included here],
+[g10_force_zlib=yes], [g10_force_zlib=no] )
+AC_MSG_RESULT($g10_force_zlib)
 
 
 AC_CANONICAL_SYSTEM
diff -urN gnupg-0.2.9/doc/gpg.1 gnupg-0.2.10/doc/gpg.1
--- gnupg-0.2.9/doc/gpg.1	Thu Feb 26 14:34:31 1998
+++ gnupg-0.2.10/doc/gpg.1	Fri Feb 27 15:28:43 1998
@@ -73,7 +73,7 @@
 .nr % 0
 .rr F
 .\}
-.TH gpg gpg.1 "26 Feb 1998" " " "GNU Tools"
+.TH gpg gpg.1 "27 Feb 1998" " " "GNU Tools"
 .IX Title "gpg gpg.1"
 .UC
 .IX Name "gpg - GNU Privacy Guard"
@@ -335,7 +335,8 @@
 \fB--homedir\fR \fIdir\fR
     Set the name of the home directory to \fIdir\fR. If this
     option is not used it defaults to \fI~/.gnupg\fR. It does
-    not make sense to use this in a options file.
+    not make sense to use this in a options file. This
+    also overrides the environment variable \f(CWGNUPGHOME\fR.
 .PP
 \fB--options\fR \fIfile\fR
     Read options from \fIfile\fR and do not try to read
@@ -428,7 +429,8 @@
 .Ve
 .SH "ENVIRONMENT"
 .IX Header "ENVIRONMENT"
-\f(CWHOME\fR   Used to locate the default home directory.
+\f(CWHOME\fR       Used to locate the default home directory.
+\f(CWGNUPGHOME\fR  If set, direcory used instead of \fI~/.gnupg\fR.
 .SH "FILES"
 .IX Header "FILES"
 \fI~/.gnupg/secring.gpg\fR     The secret key-ring
diff -urN gnupg-0.2.9/doc/gpg.1pod gnupg-0.2.10/doc/gpg.1pod
--- gnupg-0.2.9/doc/gpg.1pod	Thu Feb 26 14:31:56 1998
+++ gnupg-0.2.10/doc/gpg.1pod	Fri Feb 27 15:26:42 1998
@@ -172,7 +172,8 @@
 B<--homedir> I<dir>
     Set the name of the home directory to I<dir>. If this
     option is not used it defaults to F<~/.gnupg>. It does
-    not make sense to use this in a options file.
+    not make sense to use this in a options file. This
+    also overrides the environment variable C<GNUPGHOME>.
 
 B<--options> I<file>
     Read options from I<file> and do not try to read
@@ -266,7 +267,8 @@
 
 =head1 ENVIRONMENT
 
-C<HOME>   Used to locate the default home directory.
+C<HOME>       Used to locate the default home directory.
+C<GNUPGHOME>  If set, direcory used instead of F<~/.gnupg>.
 
 =head1 FILES
 
diff -urN gnupg-0.2.9/g10/ChangeLog gnupg-0.2.10/g10/ChangeLog
--- gnupg-0.2.9/g10/ChangeLog	Wed Feb 25 11:43:56 1998
+++ gnupg-0.2.10/g10/ChangeLog	Fri Feb 27 18:14:40 1998
@@ -1,3 +1,23 @@
+Fri Feb 27 18:14:03 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* armor.c (find_header): Removed trailing CR on headers.
+
+Fri Feb 27 18:02:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* ringedit.c (keyring_search) [MINGW32]: Open and close file here
+	because rename does not work on open files. Chnaged callers.
+
+Fri Feb 27 16:43:11 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* sig-check.c (do_check): Add an md_enable.
+	* mainproc.c (do_check_sig): Use md_open in case of detached sig
+	(proc_tree): Take detached sigs into account.
+
+Fri Feb 27 15:22:46 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (main): Make use of GNUPGHOME envvar.
+	* g10main.c (main): Ditto.
+
 Wed Feb 25 11:40:04 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* plaintext.c (ask_for_detached_datafile): add opt.verbose to
diff -urN gnupg-0.2.9/g10/armor.c gnupg-0.2.10/g10/armor.c
--- gnupg-0.2.9/g10/armor.c	Tue Feb 24 11:33:19 1998
+++ gnupg-0.2.10/g10/armor.c	Fri Feb 27 18:12:54 1998
@@ -318,6 +318,8 @@
 	    if( n < buflen || c == '\n' ) {
 		if( n && buf[0] != '\r') { /* maybe a header */
 		    if( strchr( buf, ':') ) { /* yes */
+			if( buf[n-1] == '\r' )
+			    buf[--n] = 0;
 			if( opt.verbose ) {
 			    log_info("armor header: ");
 			    print_string( stderr, buf, n );
diff -urN gnupg-0.2.9/g10/g10.c gnupg-0.2.10/g10/g10.c
--- gnupg-0.2.9/g10/g10.c	Thu Feb 26 16:49:31 1998
+++ gnupg-0.2.10/g10/g10.c	Fri Feb 27 15:34:16 1998
@@ -326,7 +326,14 @@
     opt.def_digest_algo = DIGEST_ALGO_RMD160;
     opt.completes_needed = 1;
     opt.marginals_needed = 3;
-    opt.homedir = "~/.gnupg";
+    opt.homedir = getenv("GNUPGHOME");
+    if( !opt.homedir || !*opt.homedir ) {
+      #ifdef __MINGW32__
+	opt.homedir = "c:/gnupg";
+      #else
+	opt.homedir = "~/.gnupg";
+      #endif
+    }
 
     /* check wether we have a config file on the commandline */
     orig_argc = argc;
diff -urN gnupg-0.2.9/g10/g10maint.c gnupg-0.2.10/g10/g10maint.c
--- gnupg-0.2.9/g10/g10maint.c	Tue Feb 24 16:09:35 1998
+++ gnupg-0.2.10/g10/g10maint.c	Fri Feb 27 15:35:04 1998
@@ -258,7 +258,14 @@
     opt.def_digest_algo = DIGEST_ALGO_RMD160;
     opt.completes_needed = 1;
     opt.marginals_needed = 3;
-    opt.homedir = "~/.gnupg";
+    opt.homedir = getenv("GNUPGHOME");
+    if( !opt.homedir || !*opt.homedir  ) {
+      #ifdef __MINGW32__
+	opt.homedir = "c:/gnupg";
+      #else
+	opt.homedir = "~/.gnupg";
+      #endif
+    }
 
     /* check wether we have a config file on the commandline */
     orig_argc = argc;
diff -urN gnupg-0.2.9/g10/mainproc.c gnupg-0.2.10/g10/mainproc.c
--- gnupg-0.2.9/g10/mainproc.c	Tue Feb 24 14:54:11 1998
+++ gnupg-0.2.10/g10/mainproc.c	Fri Feb 27 16:46:58 1998
@@ -272,12 +272,18 @@
 	return rc;
 
     if( sig->sig_class == 0x00 ) {
-	md = md_copy( c->mfx.md );
+	if( c->mfx.md )
+	    md = md_copy( c->mfx.md );
+	else /* detached signature */
+	    md = md_open( 0, 0 ); /* signature_check() will enable the md*/
     }
     else if( sig->sig_class == 0x01 ) {
 	/* how do we know that we have to hash the (already hashed) text
 	 * in canonical mode ??? (calculating both modes???) */
-	md = md_copy( c->mfx.md );
+	if( c->mfx.md )
+	    md = md_copy( c->mfx.md );
+	else /* detached signature */
+	    md = md_open( 0, 0 ); /* signature_check() will enable the md*/
     }
     else if( (sig->sig_class&~3) == 0x10
 	     || sig->sig_class == 0x20
@@ -620,19 +626,18 @@
     else if( node->pkt->pkttype == PKT_SIGNATURE ) {
 	PKT_signature *sig = node->pkt->pkt.signature;
 
-	if( !c->have_data && (sig->sig_class&~3) == 0x10 ) {
-	    log_info("old style signature\n");
-	    if( !c->have_data ) {
-		free_md_filter_context( &c->mfx );
-		c->mfx.md = md_open(digest_algo_from_sig(sig), 0);
-		rc = ask_for_detached_datafile( &c->mfx,
-						iobuf_get_fname(c->iobuf));
-		if( rc ) {
-		    log_error("can't hash datafile: %s\n", g10_errstr(rc));
-		    return;
-		}
+	if( !c->have_data ) {
+	    free_md_filter_context( &c->mfx );
+	    c->mfx.md = md_open(digest_algo_from_sig(sig), 0);
+	    rc = ask_for_detached_datafile( &c->mfx,
+					    iobuf_get_fname(c->iobuf));
+	    if( rc ) {
+		log_error("can't hash datafile: %s\n", g10_errstr(rc));
+		return;
 	    }
 	}
+	else
+	    log_info("old style signature\n");
 
 	check_sig_and_print( c, node );
     }
diff -urN gnupg-0.2.9/g10/ringedit.c gnupg-0.2.10/g10/ringedit.c
--- gnupg-0.2.9/g10/ringedit.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.10/g10/ringedit.c	Fri Feb 27 18:13:00 1998
@@ -73,7 +73,8 @@
 static int search( PACKET *pkt, KBPOS *kbpos, int secret );
 
 
-static int keyring_search( PACKET *pkt, KBPOS *kbpos, IOBUF iobuf );
+static int keyring_search( PACKET *pkt, KBPOS *kbpos, IOBUF iobuf,
+						const char *fname );
 static int keyring_search2( PUBKEY_FIND_INFO info, KBPOS *kbpos,
 						   const char *fname);
 static int keyring_read( KBPOS *kbpos, KBNODE *ret_root );
@@ -113,9 +114,13 @@
     if( i == MAX_RESOURCES )
 	return G10ERR_RESOURCE_LIMIT;
 
+  #if __MINGW32__
+    iobuf = NULL;
+  #else
     iobuf = iobuf_open( filename );
     if( !iobuf && !force )
 	return G10ERR_OPEN_FILE;
+  #endif
     resource_table[i].used = 1;
     resource_table[i].secret = !!secret;
     resource_table[i].fname = m_strdup(filename);
@@ -211,7 +216,8 @@
 	if( resource_table[i].used && !resource_table[i].secret == !secret ) {
 	    /* note: here we have to add different search functions,
 	     * depending on the type of the resource */
-	    rc = keyring_search( pkt, kbpos, resource_table[i].iobuf );
+	    rc = keyring_search( pkt, kbpos, resource_table[i].iobuf,
+					     resource_table[i].fname );
 	    if( !rc ) {
 		kbpos->resno = i;
 		kbpos->fp = NULL;
@@ -469,7 +475,7 @@
  * search one keyring, return 0 if found, -1 if not found or an errorcode.
  */
 static int
-keyring_search( PACKET *req, KBPOS *kbpos, IOBUF iobuf )
+keyring_search( PACKET *req, KBPOS *kbpos, IOBUF iobuf, const char *fname )
 {
     int rc;
     PACKET pkt;
@@ -482,11 +488,21 @@
     init_packet(&pkt);
     save_mode = set_packet_list_mode(0);
 
+  #if __MINGW32__
+    assert(!iobuf);
+    iobuf = iobuf_open( fname );
+    if( !iobuf ) {
+	log_error("%s: can't open keyring file\n", fname);
+	rc = G10ERR_KEYRING_OPEN;
+	goto leave;
+    }
+  #else
     if( iobuf_seek( iobuf, 0 ) ) {
 	log_error("can't rewind keyring file\n");
 	rc = G10ERR_KEYRING_OPEN;
 	goto leave;
     }
+  #endif
 
     while( !(rc=search_packet(iobuf, &pkt, pkttype, &offset)) ) {
 	if( pkt.pkttype == PKT_SECRET_CERT ) {
@@ -539,6 +555,9 @@
   leave:
     free_packet(&pkt);
     set_packet_list_mode(save_mode);
+  #if __MINGW32__
+    iobuf_close(iobuf);
+  #endif
     return rc;
 }
 
@@ -872,7 +891,11 @@
     }
 
     /* close both files */
-    iobuf_close(fp);
+    if( iobuf_close(fp) ) {
+	log_error("%s: close failed: %s\n", rentry->fname, strerror(errno) );
+	rc = G10ERR_CLOSE_FILE;
+	goto leave;
+    }
     if( iobuf_close(newfp) ) {
 	log_error("%s: close failed: %s\n", tmpfname, strerror(errno) );
 	rc = G10ERR_CLOSE_FILE;
diff -urN gnupg-0.2.9/g10/sig-check.c gnupg-0.2.10/g10/sig-check.c
--- gnupg-0.2.9/g10/sig-check.c	Mon Feb 23 13:10:49 1998
+++ gnupg-0.2.10/g10/sig-check.c	Fri Feb 27 16:43:38 1998
@@ -68,6 +68,9 @@
 
 	if( (rc=check_digest_algo(sig->d.elg.digest_algo)) )
 	    goto leave;
+	/* make sure the digest algo is enabled (in case of a detached
+	 * signature */
+	md_enable( digest, sig->d.elg.digest_algo );
 	/* complete the digest */
 	md_putc( digest, sig->sig_class );
 	{   u32 a = sig->timestamp;
@@ -124,6 +127,7 @@
 
 	if( (rc=check_digest_algo(sig->d.rsa.digest_algo)) )
 	    goto leave; /* unsupported algo */
+	md_enable( digest, sig->d.rsa.digest_algo );
 	asn = md_asn_oid( sig->d.rsa.digest_algo, &asnlen, &mdlen );
 
 	for(i=mdlen,j=asnlen-1; (c=mpi_getbyte(result, i)) != -1 && j >= 0;
diff -urN gnupg-0.2.9/g10/sign.c gnupg-0.2.10/g10/sign.c
--- gnupg-0.2.9/g10/sign.c	Tue Feb 24 15:03:39 1998
+++ gnupg-0.2.10/g10/sign.c	Fri Feb 27 16:19:44 1998
@@ -163,27 +163,30 @@
 	iobuf_push_filter( out, encrypt_filter, &efx );
     }
 
-    /* loop over the secret certificates and build headers */
-    for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
-	PKT_secret_cert *skc;
-	PKT_onepass_sig *ops;
+    if( !detached ) {
+	/* loop over the secret certificates and build headers */
+	for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
+	    PKT_secret_cert *skc;
+	    PKT_onepass_sig *ops;
 
-	skc = skc_rover->skc;
-	ops = m_alloc_clear( sizeof *ops );
-	ops->sig_class = opt.textmode && !outfile ? 0x01 : 0x00;
-	ops->digest_algo = DIGEST_ALGO_RMD160;
-	ops->pubkey_algo = skc->pubkey_algo;
-	keyid_from_skc( skc, ops->keyid );
-	ops->last = !skc_rover->next;
+	    skc = skc_rover->skc;
+	    ops = m_alloc_clear( sizeof *ops );
+	    ops->sig_class = opt.textmode && !outfile ? 0x01 : 0x00;
+	    ops->digest_algo = DIGEST_ALGO_RMD160;
+	    ops->pubkey_algo = skc->pubkey_algo;
+	    keyid_from_skc( skc, ops->keyid );
+	    ops->last = !skc_rover->next;
 
-	init_packet(&pkt);
-	pkt.pkttype = PKT_ONEPASS_SIG;
-	pkt.pkt.onepass_sig = ops;
-	rc = build_packet( out, &pkt );
-	free_packet( &pkt );
-	if( rc ) {
-	    log_error("build onepass_sig packet failed: %s\n", g10_errstr(rc));
-	    goto leave;
+	    init_packet(&pkt);
+	    pkt.pkttype = PKT_ONEPASS_SIG;
+	    pkt.pkt.onepass_sig = ops;
+	    rc = build_packet( out, &pkt );
+	    free_packet( &pkt );
+	    if( rc ) {
+		log_error("build onepass_sig packet failed: %s\n",
+							g10_errstr(rc));
+		goto leave;
+	    }
 	}
     }
 
diff -urN gnupg-0.2.9/include/memory.h gnupg-0.2.10/include/memory.h
--- gnupg-0.2.9/include/memory.h	Wed Feb 11 01:31:27 1998
+++ gnupg-0.2.10/include/memory.h	Fri Feb 27 10:38:43 1998
@@ -33,7 +33,7 @@
 #define m_realloc(n,m)		m_debug_realloc((n),(m), M_DBGINFO(__LINE__) )
 #define m_free(n)		m_debug_free((n), M_DBGINFO(__LINE__) )
 #define m_check(n)		m_debug_check((n), M_DBGINFO(__LINE__) )
-#define m_copy(a)		m_debug_copy((a), M_DBGINFO(__LINE__) )
+/*#define m_copy(a)		  m_debug_copy((a), M_DBGINFO(__LINE__) )*/
 #define m_strdup(a)		m_debug_strdup((a), M_DBGINFO(__LINE__) )
 
 void *m_debug_alloc( size_t n, const char *info );
@@ -43,7 +43,7 @@
 void *m_debug_realloc( void *a, size_t n, const char *info  );
 void m_debug_free( void *p, const char *info  );
 void m_debug_check( const void *a, const char *info );
-void *m_debug_copy( const void *a, const char *info );
+/*void *m_debug_copy( const void *a, const char *info );*/
 char *m_debug_strdup( const char *a, const char *info );
 
 #else
@@ -54,18 +54,19 @@
 void *m_realloc( void *a, size_t n );
 void m_free( void *p );
 void m_check( const void *a );
-void *m_copy( const void *a );
+/*void *m_copy( const void *a );*/
 char *m_strdup( const char * a);
 #endif
 
 size_t m_size( const void *a );
-int m_is_secure( const void *p );
 
 /*-- secmem.c --*/
 void secmem_init( size_t npool );
 void secmem_term( void );
 void *secmem_malloc( size_t size );
+void *secmem_realloc( void *a, size_t newsize );
 void secmem_free( void *a );
+int  m_is_secure( const void *p );
 void secmem_dump_stats(void);
 void secmem_set_flags( unsigned flags );
 unsigned secmem_get_flags(void);
diff -urN gnupg-0.2.9/po/gnupg.pot gnupg-0.2.10/po/gnupg.pot
--- gnupg-0.2.9/po/gnupg.pot	Thu Feb 26 16:49:47 1998
+++ gnupg-0.2.10/po/gnupg.pot	Fri Feb 27 15:35:23 1998
@@ -1,7 +1,7 @@
 msgid ""
 msgstr ""
-"Date: 1998-02-26 16:49:47+0100\n"
-"From: root <root@frodo>\n"
+"Date: 1998-02-27 15:35:23+0100\n"
+"From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
 "Files: util/secmem.c cipher/random.c g10/g10.c g10/pkclist.c g10/keygen.c\n"
@@ -266,75 +266,75 @@
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:367
+#: g10/g10.c:374
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:371
+#: g10/g10.c:378
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:378
+#: g10/g10.c:385
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:525
+#: g10/g10.c:532
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
-#: g10/g10.c:531
+#. only store the file
+#: g10/g10.c:538
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:539
+#: g10/g10.c:546
 msgid "--symmetric [filename]"
 msgstr ""
 
-#: g10/g10.c:546
+#. encrypt the given file
+#: g10/g10.c:553
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:559
+#: g10/g10.c:566
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:572
+#: g10/g10.c:579
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#. make a clearsig
-#: g10/g10.c:586
+#: g10/g10.c:593
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:594
+#. sign the key given as argument
+#: g10/g10.c:601
 msgid "--sign-key username"
 msgstr ""
 
-#: g10/g10.c:602
+#: g10/g10.c:609
 msgid "--edit-sig username"
 msgstr ""
 
-#. Chnage the passphrase
-#. no arg: use default, 1 arg use this one
-#: g10/g10.c:610
+#: g10/g10.c:617
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#: g10/g10.c:625 g10/g10.c:645 g10/g10.c:702
+#. list the given keyring
+#: g10/g10.c:632 g10/g10.c:652 g10/g10.c:709
 msgid "can't open '%s'\n"
 msgstr ""
 
-#: g10/g10.c:656
+#: g10/g10.c:663
 msgid "-k[v][v][v][c] [keyring]"
 msgstr ""
 
-#. generate a key (interactive)
-#: g10/g10.c:661
+#: g10/g10.c:668
 msgid "--gen-key"
 msgstr ""
 
-#: g10/g10.c:700
+#: g10/g10.c:707
 msgid "[filename]"
 msgstr ""
 
diff -urN gnupg-0.2.9/tools/Makefile.in gnupg-0.2.10/tools/Makefile.in
--- gnupg-0.2.9/tools/Makefile.in	Thu Feb 26 17:13:28 1998
+++ gnupg-0.2.10/tools/Makefile.in	Fri Feb 27 18:23:57 1998
@@ -235,7 +235,7 @@
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/blowfish.h ../include/../cipher/gost.h \
 	../include/../cipher/elgamal.h ../include/i18n.h
-clean-sat.o clean-sat.lo: clean-sat.c
+clean-sat.o: clean-sat.c
 mpicalc.o: mpicalc.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/i18n.h
diff -urN gnupg-0.2.9/util/ChangeLog gnupg-0.2.10/util/ChangeLog
--- gnupg-0.2.9/util/ChangeLog	Thu Feb 26 14:37:43 1998
+++ gnupg-0.2.10/util/ChangeLog	Fri Feb 27 10:37:07 1998
@@ -1,3 +1,11 @@
+Fri Feb 27 10:20:03 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* memory.c (m_is_secure): Removed.
+	* secmem.c (m_is_secure): Moved to here.
+
+	* secmem.c (secmem_realloc): New.
+	* memory.c (M_GUARD,EXTRA_ALIGN): New (all functions).
+
 Thu Feb 26 14:36:51 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* secmem.c (lock_pool): No error if EAGAIN is returned instead
diff -urN gnupg-0.2.9/util/memory.c gnupg-0.2.10/util/memory.c
--- gnupg-0.2.9/util/memory.c	Mon Feb 23 13:11:24 1998
+++ gnupg-0.2.10/util/memory.c	Fri Feb 27 12:46:28 1998
@@ -4,13 +4,11 @@
  * We use our own memory allocation functions instead of plain malloc(),
  * so that we can provide some special enhancements:
  *  a) functions to provide memory from a secure memory.
- *     Don't know how to handle it yet, but it may be possible to
- *     use memory which can't be swapped out.
  *  b) By looking at the requested allocation size we
  *     can reuse memory very quickly (e.g. MPI storage)
- *  c) A controlbyte gives us the opportunity to use only one
- *     free() function and do some overflow checking.
- *  d) memory checking and reporting if compiled with M_DEBUG
+ *     (really needed?)
+ *  c) memory usage reporting if compiled with M_DEBUG
+ *  d) memory checking if compiled with M_GUARD
  *
  * This file is part of GNUPG.
  *
@@ -44,9 +42,18 @@
 #define MAGIC_SEC_BYTE 0xcc
 #define MAGIC_END_BYTE 0xaa
 
+#if SIZEOF_UNSIGNED_LONG == 8
+  #define EXTRA_ALIGN 4
+#else
+  #define EXTRA_ALIGN 0
+#endif
+
 const void membug( const char *fmt, ... );
 
 #ifdef M_DEBUG
+  #ifndef M_GUARD
+    #define M_GUARD 1
+  #endif
   #undef m_alloc
   #undef m_alloc_clear
   #undef m_alloc_secure
@@ -64,10 +71,10 @@
   #define FNAME(a)  m_ ##a
   #define FNAMEPRT
   #define FNAMEARG
-  #define store_len(p,n,m) do { ((byte*)p)[0] = n;		    \
-				((byte*)p)[1] = n >> 8 ;	    \
-				((byte*)p)[2] = n >> 16 ;	    \
-				((byte*)p)[3] = m? MAGIC_SEC_BYTE   \
+  #define store_len(p,n,m) do { ((byte*)p)[EXTRA_ALIGN+0] = n;		      \
+				((byte*)p)[EXTRA_ALIGN+1] = n >> 8 ;	      \
+				((byte*)p)[EXTRA_ALIGN+2] = n >> 16 ;	      \
+				((byte*)p)[EXTRA_ALIGN+3] = m? MAGIC_SEC_BYTE \
 						 : MAGIC_NOR_BYTE;  \
 			      } while(0)
 #endif
@@ -196,24 +203,29 @@
     unsigned n;
     struct memtbl_entry *e;
 
-    n  = p[0];
-    n |= p[1] << 8;
-    n |= p[2] << 16;
+    n  = p[EXTRA_ALIGN+0];
+    n |= p[EXTRA_ALIGN+1] << 8;
+    n |= p[EXTRA_ALIGN+2] << 16;
 
     if( n >= memtbl_len )
 	membug("memory at %p corrupted: index=%u table_len=%u (%s)\n",
-						 p+4, n, memtbl_len, info );
+				      p+EXTRA_ALIGN+4, n, memtbl_len, info );
     e = memtbl+n;
 
-    if( e->user_p != p+4 )
-	membug("memory at %p corrupted: reference mismatch (%s)\n", p+4, info );
+    if( e->user_p != p+EXTRA_ALIGN+4 )
+	membug("memory at %p corrupted: reference mismatch (%s)\n",
+							p+EXTRA_ALIGN+4, info );
     if( !e->inuse )
-	membug("memory at %p corrupted: marked as free (%s)\n", p+4, info );
+	membug("memory at %p corrupted: marked as free (%s)\n",
+							p+EXTRA_ALIGN+4, info );
 
-    if( !(p[3] == MAGIC_NOR_BYTE || p[3] == MAGIC_SEC_BYTE) )
-	membug("memory at %p corrupted: underflow=%02x (%s)\n", p+4, p[3], info );
-    if( p[4+e->user_n] != MAGIC_END_BYTE )
-	membug("memory at %p corrupted: overflow=%02x (%s)\n", p+4, p[4+e->user_n], info );
+    if( !(p[EXTRA_ALIGN+3] == MAGIC_NOR_BYTE
+	|| p[EXTRA_ALIGN+3] == MAGIC_SEC_BYTE) )
+	membug("memory at %p corrupted: underflow=%02x (%s)\n",
+				 p+EXTRA_ALIGN+4, p[EXTRA_ALIGN+3], info );
+    if( p[EXTRA_ALIGN+4+e->user_n] != MAGIC_END_BYTE )
+	membug("memory at %p corrupted: overflow=%02x (%s)\n",
+		     p+EXTRA_ALIGN+4, p[EXTRA_ALIGN+4+e->user_n], info );
     return e;
 }
 
@@ -233,10 +245,10 @@
 	log_debug( "%s frees %u bytes alloced by %s\n",
 				info, e->user_n, e->info->info );
     if( !e->inuse ) {
-	if( e->user_p == p + 4 )
-	    membug("freeing an already freed pointer at %p\n", p+4 );
+	if( e->user_p == p + EXTRA_ALIGN+ 4 )
+	    membug("freeing an already freed pointer at %p\n", p+EXTRA_ALIGN+4 );
 	else
-	    membug("freeing pointer %p which is flagged as freed\n", p+4 );
+	    membug("freeing pointer %p which is flagged as freed\n", p+EXTRA_ALIGN+4 );
     }
 
     e->inuse = 0;
@@ -298,7 +310,7 @@
 
     for( e = memtbl, n = 0; n < memtbl_len; n++, e++ )
 	if( e->inuse )
-	    check_mem(e->user_p-4, info);
+	    check_mem(e->user_p-4-EXTRA_ALIGN, info);
 }
 
 #endif /* M_DEBUG */
@@ -337,11 +349,17 @@
 {
     char *p;
 
-    if( !(p = malloc( n + 5 )) )
+  #ifdef M_GUARD
+    if( !(p = malloc( n + EXTRA_ALIGN+5 )) )
 	out_of_core(n,0);
     store_len(p,n,0);
-    p[4+n] = MAGIC_END_BYTE; /* need to add the length somewhere */
-    return p+4;
+    p[4+EXTRA_ALIGN+n] = MAGIC_END_BYTE;
+    return p+EXTRA_ALIGN+4;
+  #else
+    if( !(p = malloc( n )) )
+	out_of_core(n,0);
+    return p;
+  #endif
 }
 
 /****************
@@ -353,11 +371,17 @@
 {
     char *p;
 
-    if( !(p = secmem_malloc( n + 5 )) )
+  #ifdef M_GUARD
+    if( !(p = secmem_malloc( n +EXTRA_ALIGN+ 5 )) )
 	out_of_core(n,1);
     store_len(p,n,1);
-    p[4+n] = MAGIC_END_BYTE;
-    return p+4;
+    p[4+EXTRA_ALIGN+n] = MAGIC_END_BYTE;
+    return p+EXTRA_ALIGN+4;
+  #else
+    if( !(p = secmem_malloc( n )) )
+	out_of_core(n,1);
+    return p;
+  #endif
 }
 
 void *
@@ -384,7 +408,8 @@
  */
 void *
 FNAME(realloc)( void *a, size_t n FNAMEPRT )
-{   /* FIXME: should be optimized :-) */
+{
+  #ifdef M_GUARD
     unsigned char *p = a;
     void *b;
     size_t len = m_size(a);
@@ -398,6 +423,18 @@
     FNAME(check)(NULL FNAMEARG);
     memcpy(b, a, len );
     FNAME(free)(p FNAMEARG);
+  #else
+    void *b;
+
+    if( m_is_secure(a) ) {
+	if( !(b = secmem_realloc( a, n )) )
+	    out_of_core(n,1);
+    }
+    else {
+	if( !(b = realloc( a, n )) )
+	    out_of_core(n,0);
+    }
+  #endif
     return b;
 }
 
@@ -414,13 +451,18 @@
     if( !p )
 	return;
   #ifdef M_DEBUG
-    free_entry(p-4, info);
-  #else
+    free_entry(p-EXTRA_ALIGN-4, info);
+  #elif  M_GUARD
     m_check(p);
     if( m_is_secure(a) )
-	secmem_free(p-4);
+	secmem_free(p-EXTRA_ALIGN-4);
     else
-	free(p-4);
+	free(p-EXTRA_ALIGN-4);
+  #else
+    if( m_is_secure(a) )
+	secmem_free(p);
+    else
+	free(p);
   #endif
 }
 
@@ -428,11 +470,12 @@
 void
 FNAME(check)( const void *a FNAMEPRT )
 {
+  #ifdef M_GUARD
     const byte *p = a;
 
   #ifdef M_DEBUG
     if( p )
-	check_mem(p-4, info);
+	check_mem(p-EXTRA_ALIGN-4, info);
     else
 	check_allmem(info);
   #else
@@ -443,33 +486,33 @@
     else if( p[m_size(p)] != MAGIC_END_BYTE )
 	membug("memory at %p corrupted (overflow=%02x)\n", p, p[-1] );
   #endif
+  #endif
 }
 
 
 size_t
 m_size( const void *a )
 {
+  #ifndef M_GUARD
+    log_debug("Ooops, m_size called\n");
+    return 0;
+  #else
     const byte *p = a;
     size_t n;
 
   #ifdef M_DEBUG
-    n = check_mem(p-4, "m_size")->user_n;
+    n = check_mem(p-EXTRA_ALIGN-4, "m_size")->user_n;
   #else
     n  = ((byte*)p)[-4];
     n |= ((byte*)p)[-3] << 8;
     n |= ((byte*)p)[-2] << 16;
   #endif
     return n;
+  #endif
 }
 
 
-int
-m_is_secure( const void *p )
-{
-    return p && ((byte*)p)[-1] == MAGIC_SEC_BYTE;
-}
-
-
+#if 0 /* not used */
 /****************
  * Make a copy of the memory block at a
  */
@@ -482,7 +525,7 @@
     if( !a )
 	return NULL;
 
-    n = m_size(a);
+    n = m_size(a); Aiiiih woher nehmen
     if( m_is_secure(a) )
 	b = FNAME(alloc_secure)(n FNAMEARG);
     else
@@ -490,7 +533,7 @@
     memcpy(b, a, n );
     return b;
 }
-
+#endif
 
 char *
 FNAME(strdup)( const char *a FNAMEPRT )
diff -urN gnupg-0.2.9/util/secmem.c gnupg-0.2.10/util/secmem.c
--- gnupg-0.2.9/util/secmem.c	Thu Feb 26 15:34:57 1998
+++ gnupg-0.2.10/util/secmem.c	Fri Feb 27 13:13:47 1998
@@ -219,6 +219,25 @@
 }
 
 
+void *
+secmem_realloc( void *p, size_t newsize )
+{
+    MEMBLOCK *mb;
+    size_t size;
+    void *a;
+
+    mb = (MEMBLOCK*)((char*)p - ((size_t) &((MEMBLOCK*)0)->u.d));
+    size = mb->size;
+    if( newsize < size )
+	return p; /* it is easier not to shrink the memory */
+    a = secmem_malloc( newsize );
+    memcpy(a, p, size);
+    memset(a+size, 0, newsize-size);
+    secmem_free(p);
+    return a;
+}
+
+
 void
 secmem_free( void *a )
 {
@@ -239,6 +258,12 @@
     unused_blocks = mb;
     cur_blocks--;
     cur_alloced -= size;
+}
+
+int
+m_is_secure( const void *p )
+{
+    return p >= pool && p < (pool+poolsize);
 }
 
 void
